Scriptname DBM_CardDeckBuildScript extends ObjectReference  

{Script to complete a deck on activating a Fate Card from your inventory.}

FormList Property CardList Auto
MiscObject Property CompleteDeck Auto
GlobalVariable Property DBM_CardStart Auto
Message Property DBM_CardMSG Auto

Bool Abort
String sMissingCards

Event OnContainerChanged(ObjectReference akNewContainer, ObjectReference akOldContainer)
	if akNewContainer == Game.GetPlayer()
		if DBM_CardStart.GetValue() == 0
			DBM_CardMSG.show()
			DBM_CardStart.Setvalue(1)
		endif
	endif
Endevent

Event OnEquipped(Actor akActor)
	if akActor == Game.GetPlayer()
		Abort = FALSE
		sMissingCards = ""
		int index = 0
		int total = CardList.GetSize()
		
		while index < total
			Form Card = CardList.GetAt(index)
			if !akActor.GetItemCount(Card)
				MissingCard(index + 1)
				Abort = True
			endif
			index += 1
		endwhile
		
		if Abort
			Debug.Messagebox("You cannot make a deck because you are missing the following cards: "+sMissingCards)
		else
			akActor.RemoveItem(CardList,1,True)
			akActor.AddItem(CompleteDeck, 1, False)
		endif
	endif
EndEvent

Function MissingCard(int aiNumber)
	if sMissingCards != ""
		sMissingCards = sMissingCards+", "
	endif
	
	if aiNumber == 1
		sMissingCards = sMissingCards + "Ace"
	elseif aiNumber == 11
		sMissingCards = sMissingCards + "Jack"
	elseif aiNumber == 12
		sMissingCards = sMissingCards + "Queen"
	elseif aiNumber == 13
		sMissingCards = sMissingCards + "King"
	else
		sMissingCards = sMissingCards +aiNumber
	endif
EndFunction