Scriptname DBM_CloakDisplayScript extends ObjectReference  

Armor C1
Armor C2
ObjectReference O

FormList Property DisplayList Auto
FormList Property CloakList Auto

ObjectReference Property DBM_CloaksUtility Auto

String Property MYMOD1 Auto
String Property MYMOD2 Auto

Int[] Property Armor1 Auto
Int[] Property Armor2 Auto

GlobalVariable Property DBM_DisplayMAX Auto

bool CloaksESP
bool CCOR

Event OnInit()
	if Game.GetModByName("Cloaks.esp") != 255
		CloaksESP = True
	endif
	
	if Game.GetModByName("Complete Crafting Overhaul_Remade.esp") != 255
		CCOR = True
	endif
	
	Int CNT = DisplayList.GetSize()
	Int Index = 0
	While index < CNT
			if CloaksESP && !CCOR
				C1 = Game.GetFormFromFile(Armor1[Index], MYMOD1) as Armor
				CloakList.AddForm(C1)
			Elseif CCOR
				C2 = Game.GetFormFromFile(Armor2[Index], MYMOD2) as Armor
				CloakList.AddForm(C2)
			Endif
			Index += 1
	EndWhile
	
	DBM_CloaksUtility.AddItem(CloakList,1)
	
	if CloaksESP && CCOR
		Debug.Trace("<<ERROR>> Cloaks of Skyrim and CCOR detected, it is highly recommend you only run one of these.")
	EndIf
EndEvent

Auto State Waiting
	Event OnActivate(ObjectReference akActionRef)
		BlockActivation()
		Utility.Wait(1.0)
		GoToState("Sorting")
		ResetDisplays()
		UpdateDisplay()
	EndEvent
EndState


State Sorting

Event OnActivate(ObjectReference akActionRef)
	debug.notification("Displaying items, please wait")
EndEvent

EndState


Function UpdateDisplay()

	Int Index = DisplayList.GetSize()

	While index
			Index -= 1
			if CloaksESP && !CCOR
				C1 = Game.GetFormFromFile(Armor1[Index], MYMOD1) as Armor
				O = DISPLAYLIST.GetAt(index) as ObjectReference
					if Self.GetItemCount(C1) >= 1
						O.Enable()
						DBM_DisplayMax.Value += 1
					Endif
			Elseif CCOR
				C2 = Game.GetFormFromFile(Armor2[Index], MYMOD2) as Armor
				O = DISPLAYLIST.GetAt(index) as ObjectReference
					if Self.GetItemCount(C2) >= 1
						O.Enable()
						DBM_DisplayMax.Value += 1
					Endif
			Endif
	EndWhile
	GoToState("Waiting")
	BlockActivation(False)
EndFunction

Function ResetDisplays()
	int ItmCount = DisplayList.GetSize()
	int Index = ItmCount
	While index
			Index -= 1
			O = DisplayList.GetAt(index) as Objectreference
			if !O.IsDisabled()
				O.Disable()
				DBM_DisplayMax.Value -= 1
			endif
	EndWhile
EndFunction
