Scriptname DBM_MAASE_DweKeyDoorScript extends ObjectReference  
{Controller script for Green and Blue doors.}

Quest Property MAASE_Quest Auto
{Much Ado About Snow Elves}

ObjectReference Property KeyInUse Auto
{Key used during unlock animation}
Key Property ColourKey Auto
{Blue or Green key}
MiscObject Property DeadKey auto
{Depleted key}

Effectshader Property DoorShader auto
{Coloured shader effect on doors}
Visualeffect Property KeyVFX auto
{VFX for coloured key}

Sound Property DoorBuzz auto
{Sound when player does not have the key}
Sound Property UnlockSFX auto
{Sound when door unlocks}

Int Property ExploreObj Auto
{Objective when not been here before}
Int Property KeyNotFound Auto
{Stage when player doesn't have the right key}
Int Property KeyFound Auto
{Stage when player has the right key.}
Int OneTime

Event OnCellLoad()
	DoorShader.Play(self as ObjectReference, -1.00000)
	if !self.IsLocked() && !MAASE_Quest.GetStageDone(310)
		Lock()
	endif
EndEvent

Event OnActivate(ObjectReference akPlayer)
Int DoOnce = 0
	if akPlayer == Game.GetPlayer() && self.IsLocked() && akPlayer.GetItemCount(ColourKey) == 0
		KeyVFX.Play(self as ObjectReference, 4.00000, none)
		DoorBuzz.Play(self as ObjectReference)
		if MAASE_Quest.IsObjectiveDisplayed(ExploreObj) && DoOnce == 0
			MAASE_Quest.SetStage(KeyNotFound)
			DoOnce = 1
		else
		debug.notification("The Door hums ominously but won't budge without some kind of key.")
		endif
	Elseif akPlayer == Game.GetPlayer() && akPlayer.GetItemCount(ColourKey) >= 1 && self.IsLocked()
		;MAASE_Quest.SetStage(KeyFound) - Hidden as does not work. Trigger behind door replaces function.
		Lock(False) ;Unlock the door, I have they key.
	Elseif !self.IsLocked() && DoOnce == 1
		debug.Notification("Looks like the mechanism seized after it opened.")
	EndIf
EndEvent

Event OnLockStateChanged()
	if OneTime == 0 && !IsLocked()
		Game.GetPlayer().RemoveItem(ColourKey, 1, false, none)
		KeyInUse.SetMotionType(self.Motion_Keyframed, false)
		KeyInUse.MoveToNode(self as ObjectReference, "keyhole")
		UnlockSFX.Play(self)
		KeyVFX.Play(self as ObjectReference, 4.00000, none)
		Utility.Wait(4)
		DoorShader.Stop(self)
		KeyInUse.Disable()
		Game.GetPlayer().AddItem(DeadKey, 1, false)
		OneTime = 1
	EndIf
EndEvent