Scriptname DBM_MAASE_IrkBossScript extends Actor  
{Controls the Boss Actor during MAASE Final Battle.}

GlobalVariable Property BossLives Auto
{Boss lives Global, increases on each death}
Quest Property MAASE_Quest Auto
{Much Ado About Snow Elves}

ObjectReference Property Jekyll Auto
{The good guy ghost}
ActorBase Property Hyde Auto
{The bad guy shade as base actor}
Actor Property GhostRemnant1 Auto
{GR from Scene 1}
Actor Property GhostRemnant2 Auto
{GR from Scene 2}
Actor Property GhostRemnant3 Auto
{GR from Scene 3}
Actor Property GhostRemnant4 Auto
{GR from Scene 4}
Sound Property RemnantVoice Auto
{Renmant jibberish}

Scene Property SaveMeScene Auto
{Scene during combat}
Sound Property HelpCry Auto
{Cry for help during intermittent scene.}
Sound Property Scream Auto
{Boss scream}
Sound Property DeathSFX Auto
{SFX for boss final defeat}
ObjectReference Property FinalMarker Auto
{Marker for Final Scene Start}
Scene Property FinalScene Auto
{Ending scene}

Explosion Property DramaticExit Auto
{VFX when ghosts despawn}
Explosion Property DramaticEntrace Auto
{VFX when boss appears}
Spell Property Blizzard Auto
{Blizzard Spell}
Spell Property IceStorm Auto
{IceStorm spell}

Float Lives ;BossLives as Float
Int Delay ;Delay between respawns
Actor GhostRemnant ;GhostRemnant for intermittent scenes
Scene SaveMeScene ;Scene to play between boss respawns

Function OnDeath(Actor akHero)
Delay = 0
;Lives = BossLives.GetValue()
(MAASE_Quest.GetAlias(26) as ReferenceAlias).Clear()
	if BossLives.Value == 0 ;1st death
		(MAASE_Quest.GetAlias(26) as ReferenceAlias).ForceRefTo(GhostRemnant1)
		(Jekyll as Actor).SetAlpha(0.2, true)
		PrepareForRespawn()
	Elseif BossLives.Value == 1 ;2nd death
		(MAASE_Quest.GetAlias(26) as ReferenceAlias).ForceRefTo(GhostRemnant2)
		(Jekyll as Actor).SetAlpha(0.3, true)
		PrepareForRespawn()
	Elseif BossLives.Value == 2 ;3rd death
		(MAASE_Quest.GetAlias(26) as ReferenceAlias).ForceRefTo(GhostRemnant3)
		(Jekyll as Actor).SetAlpha(0.4, true)
		PrepareForRespawn()
	Elseif BossLives.Value == 3 ;4th death
		(MAASE_Quest.GetAlias(26) as ReferenceAlias).ForceRefTo(GhostRemnant4)
		(Jekyll as Actor).SetAlpha(0.5, true)
		PrepareForRespawn()
	Else ;5th death
		BossLives.Value += 1
		DeathSFX.Play(akHero)
		(Jekyll as Actor).SetAlpha(0.1, true)
		Jekyll.Enable()
		Utility.Wait(3)
		GhostRemnant1.Enable(true)
		Int RV1 = RemnantVoice.Play(GhostRemnant1)
		Sound.SetInstanceVolume(RV1,0.1) ;TURN DOWN JIBBERISH SFX
		GhostRemnant2.Enable(true)
		Int RV2 = RemnantVoice.Play(GhostRemnant2)
		Sound.SetInstanceVolume(RV2,0.1) ;TURN DOWN JIBBERISH SFX
		GhostRemnant3.Enable(true)
		Int RV3 = RemnantVoice.Play(GhostRemnant3)
		Sound.SetInstanceVolume(RV3,0.1) ;TURN DOWN JIBBERISH SFX
		GhostRemnant4.Enable(true)
		Int RV4 = RemnantVoice.Play(GhostRemnant4)
		Sound.SetInstanceVolume(RV4,0.1) ;TURN DOWN JIBBERISH SFX
		FinalScene.Start()
		Self.Delete()
	EndIf
EndFunction

Function OnUpdate()
Delay += 1
Actor Remnant = (MAASE_Quest.GetAlias(26) as ReferenceAlias).GetRef() as Actor
	if Delay == 7 ;Remnant.GetDistance(Jekyll) < 200 removed as condition to prevent stalling.
		self.UnregisterForUpdate()
		SaveMeScene.Stop()
		Remnant.PlaceAtMe(DramaticExit,1,0,0)
		Remnant.DisableNoWait()
		Jekyll.PlaceAtMe(DramaticExit,1,0,0)
		Jekyll.DisableNoWait()
		Utility.Wait(2)
		Jekyll.PlaceAtMe(DramaticEntrace,1,0,0)
		Scream.Play(Game.GetPlayer())
		Actor NextBoss = Self.PlaceAtMe(Hyde,1,0,0) as Actor
		Float BossScale = 0.05
		NextBoss.SetScale(BossScale)
		while BossScale < 1
			BossScale += 0.05
			NextBoss.SetScale(BossScale)
		endwhile
		NextBoss.SendAssaultAlarm()
		NextBoss.StartCombat(Game.GetPlayer())
		if BossLives.Value >= 3
			IceStorm.Cast(NextBoss, Game.GetPlayer())
			int ShowOnce = 0
			if ShowOnce == 0
				ShowOnce += 1
				NextBoss.SetAlpha(0.5,true)
				debug.notification("The shade is weakening, keep it up!")
			endif
		else
			Blizzard.Cast(NextBoss)
		endIf
		Self.Delete()
	endIf
EndFunction

Function PrepareForRespawn()
	Jekyll.MoveTo(Self,0,0,0,true)
	Jekyll.Enable(true)
	HelpCry.Play(Game.GetPlayer())
	SaveMeScene.Start()
	BossLives.Value += 1
	Self.RegisterForUpdate(2)
EndFunction