Scriptname DBM_MAASE_IrkGhostBattleScript extends ObjectReference  
{Controller Script for MAASE Final Battle}

Actor Property Ghost Auto
{The non-hostile Snow Elve Ghost}
ActorBase Property Boss Auto
{Base actor for Wisp Boss}
ObjectReference Property RevealLocation Auto
{Spot the ghost appears on trigger}
Scene Property Transformation Auto
{Scene where ghost becomes shade}
Quest Property MAASE_Quest Auto
{MuchAdoAboutSnowElves}


Sound Property EvilLaugh Auto
{Evil cackle}
Sound Property Sorry Auto
{Ghost is fading}

Explosion Property DramaticExit Auto
{Exit "poof"}
Explosion Property DramaticEntrance Auto
{Appear "poof"}
Spell Property Blizzard Auto
{Fills zone with Ice Blizzard}
Actor BossShade

Function OnTriggerEnter (ObjectReference OurHero)
	if OurHero == Game.GetPlayer() && MAASE_Quest.IsRunning() && !MAASE_Quest.IsCompleted()
		Ghost.MoveTo(RevealLocation)
		Ghost.Enable(True)
		Utility.Wait(2)
		Ghost.SetAlpha(0,false)
		EvilLaugh.Play(OurHero)
		Transformation.Start()
		Utility.Wait(1)
		Ghost.SetAlpha(0.3,true)
		Sorry.Play(OurHero)
		Utility.Wait(0.5)
		Ghost.Disable(True)
		Transformation.Stop()
		Ghost.PlaceAtMe(DramaticExit,1,0,0)
		Ghost.PlaceAtMe(DramaticEntrance,1,0,0)
		BossShade = Ghost.PlaceActorAtMe(Boss)
		BossShade.SendAssaultAlarm()
		BossShade.StartCombat(Game.GetPlayer())
		Blizzard.Cast(BossShade, Game.GetPlayer())
		Self.Disable()
	EndIf
EndFunction