Scriptname DBM_MAASE_KeyChargerScript extends ObjectReference  
{Controller for key charging container}

MiscObject Property DeadKey Auto
{A depleated door key}
Key Property ChargedKey Auto
{The charged version of the key.}

Sound Property SFX Auto
{Key charge sound}
Sound Property RejectSound Auto
{Sound when wrong item is inserted.}

VisualEffect Property VFX Auto
{Visual effect for key charge}
Explosion Property Overload Auto
{Explosion rendering the chest inoperable}

Function OnItemAdded(Form akBaseItem, Int aiItemCount, ObjectReference akItemReference, ObjectReference CuriousGeorge)
Int DoOnce = 0
	if akBaseItem == DeadKey && CuriousGeorge == Game.GetPlayer() && DoOnce == 0
		DoOnce = 1
		Utility.Wait(1)
		SFX.Play(CuriousGeorge)
		VFX.Play(self,-1,none)
		Utility.Wait(1)
		Self.PlaceAtMe(Overload,1,0,0)
		Self.RemoveItem(akItemReference)
		Utility.Wait(3)
		CuriousGeorge.AddItem(ChargedKey)
		VFX.Stop(self)
		Debug.MessageBox("The newly charged key pops out the top of the container and lands in your hands.")
		Self.DisableNoWait(False)
	Elseif akBaseItem != DeadKey
		Self.RemoveItem(akBaseItem,1,false,CuriousGeorge)
		RejectSound.Play(self)
		Debug.Messagebox("The container seems to reject that item.")
	EndIf
EndFunction