Scriptname DBM_MAASE_PedestalScript extends ObjectReference  
{Control Script for Dwemer Display Pedestals - rewritten by Pickysaurus}

ObjectReference property GreenDoor auto
{Xrib Green Door - will lock once loot collected.}
ObjectReference property StaffXribDisplay auto
{Dummy staff in Xrib Temple}
ObjectReference property StaffIrkDisplay auto
{Dummy staff in Irkgthand}
ObjectReference property SunBlessedDisplay auto
{Shield dummy in Xrib Temple}

Location Property SightlessPitLocaiton auto
{Sightless Pit - Xrib Location}
Location Property IrkngthandLocaiton auto
{Irkngthand Location}

sound property PickUpShldSFX auto
{SoundFX for taking shield from display}
sound property PickUpStaffSFX auto
{SoundFX for taking staff from display}
sound property WARNING auto
{SoundFX when player touches ForceField}


spell property Zap auto
{Lightining bolt from display for touching ForceField}

weapon property StaffXrib auto
{Staff from Temple of Xrib}
weapon property StaffIrk auto
{Staff from Irkgthand Refugee Annex}
weapon property IrkBAxe auto
{Battleaxe in Irkgthand}
armor property SunBlessed auto
{Sun Blessed shield in Xrib}


formlist property ForceFieldList auto
{FormList for Static Forcefields}
formlist property XribStasisList auto
{FormList holding Xrib Staff}
formlist property StasisShield auto
{ForList holding Sunblesssed Shield and Statue}
formlist property IrkStasisList auto
{FormList holding Irkgthand Staff and Battleaxe}

ObjectReference Focus 

Function OnActivate (ObjectReference akWhoDid)
	if akWhoDid == Game.GetPlayer()
	ObjectReference ForceField = game.FindClosestReferenceOfAnyTypeInListFromRef(ForceFieldList, self as ObjectReference, 250.000) ;find nearest forcefield
		if ForceField == none || ForceField.IsDisabled() ;no active forcefield
			if Forcefield.IsInLocation(SightlessPitLocaiton) ;if in Xrib Temple
			Focus = game.FindClosestReferenceOfAnyTypeInListFromRef(XribStasisList, self as ObjectReference, 250.000) ;look for Xrib Stuff
				if !Focus.IsDisabled() && Focus == StaffXribDisplay
				akWhodid.AddItem(StaffXrib as form, 1, false)
				PickUpStaffSFX.Play(akWhodid)
				Focus.DisableNoWait(false)
				Focus = None
				ForceField = None
				EndIf
			Focus = game.FindClosestReferenceOfAnyTypeInListFromRef(StasisShield, self as ObjectReference, 250.000) ;look for Sunblessed shield (initial cast)
				if Focus == SunBlessedDisplay
				akWhodid.AddItem(SunBlessed as form, 1, false)
				PickUpShldSFX.Play(akWhodid)
				Focus.DisableNoWait(false)
				Focus = None
				ForceField = None
				EndIf
			elseif Forcefield.IsInLocation(IrkngthandLocaiton) ;if in Irkngthand
			Focus = game.FindClosestReferenceOfAnyTypeInListFromRef(IrkStasisList, self as ObjectReference, 250.000) ;look for Xrib Stuff
				if !Focus.IsDisabled() && Focus == StaffIrkDisplay ;staff display
				akWhodid.AddItem(StaffIrk as form, 1, false)
				PickUpStaffSFX.Play(akWhodid)
				Focus.DisableNoWait(false)
				Focus = None
				ForceField = None
				elseif !Focus.IsDisabled() 
				akWhodid.AddItem(IrkBAxe as form, 1, false) ;battleaxe display
				PickUpStaffSFX.Play(akWhodid)
				Focus.DisableNoWait(false)
				Focus = None
				ForceField = None
				EndIf
			elseif Focus == none || Focus.IsDisabled()
			debug.Notification("There is nothing in the chamber.")
			EndIf
		else ;The Shield's still up It's a Trap!
		Actor Trgt = akWhodid as Actor
		Zap.Cast(self, Trgt)
		Trgt.DamageActorValue("health", 25 as Float)
		WARNING.Play(self)
		debug.Notification("You'll need to find a way to disable this device before you can take anything out of it!")
		EndIf
	endIf
EndFunction