Scriptname DBM_MalrusMenuEFFScript extends activemagiceffect  

ObjectReference Property DISPLAYCHEST Auto

;SUT
Quest Property DBM_MalrusSUTChestHandler Auto
ObjectReference Property SUTStuff1 Auto

;Aethereal
Form Ore
Form Ingot
ObjectReference Property AetherealStuff Auto
LeveledItem Property DBM_AetheriumOreList Auto
LeveledItem Property DBM_AetheriumIngotList Auto

;Fossil mod
GlobalVariable Chance
ObjectReference Property FossilStuff Auto

;Fish Bowls
FormList Property DBM_FishItems Auto
ObjectReference Property FishBowls Auto
Spell Property DBM_MalrusAquaABIL Auto

;Fairy Cages
FormList Property DBM_FairyItems Auto
ObjectReference Property FairyCages Auto
Spell Property DBM_MalrusFairyABIL Auto

;TGCON
ObjectReference Property CowlRef Auto
FormList Property DBM_MalrusCodexGCLocations Auto

; Wyrmstooth
ObjectReference Property WyrmstoothStuff Auto
FormList Property DBM_MalrusCodexWTLocations Auto

; Falskaar
ObjectReference Property FalskaarStuff Auto
FormList Property DBM_MalrusCodexFSLocations Auto

ObjectReference O
Int LOCNum
Int LOCTotal

GlobalVariable Property BLOCK Auto
Message Property MalrusMenu Auto
Message Property MalrusMenu2 Auto
DBM__QF_DBM_MalrusCodexHandle_0600AA0E Property MyQST Auto

Event OnEffectStart(Actor akTarget, Actor akCaster)
if akCaster == Game.GetPlayer() 
	If BLOCK.Value == 0
		int Btn = MalrusMenu.Show()
		if Btn == 0 ; SUT
			If SUTStuff1.IsEnabled()
				DBM_MalrusSUTChestHandler.SetStage(5)
				BLOCK.Value = 1
				MyQST.RegisterForSingleUpdateGameTime(24)
			Endif
		Elseif Btn == 1 ; Aethereal
			If AetherealStuff.IsEnabled()
				Ore = Game.GetFormFromFile(0x009295,"AetheriumSwordsnArmor.esp")
				Ingot = Game.GetFormFromFile(0x009294,"AetheriumSwordsnArmor.esp")
				DBM_AetheriumOreList.AddForm(Ore, 1, 3)
				DBM_AetheriumIngotList.AddForm(Ingot, 1, 1)
				BLOCK.Value = 1
				MyQST.RegisterForSingleUpdateGameTime(24)
				Debug.Messagebox("You are more likely to find Aetherium in large Dwemer chests for the next 24 hours")
			Endif
		Elseif Btn == 2 ; Fossil
			If FossilStuff.IsEnabled()
				Chance = Game.GetFormFromFile(0x00867E,"Fossilsyum.esp") as GlobalVariable
				Chance.Value = 75
				BLOCK.Value = 1
				MyQST.RegisterForSingleUpdateGameTime(24)
				Debug.Messagebox("You have a better chance of finding fossils for the next 24 hours")
			Endif
		Elseif Btn == 3 ; Something Fishy
			if FishBowls.IsEnabled()
				if DISPLAYCHEST.GetItemCount(DBM_FishItems) >= 8
					Game.GetPlayer().Addspell(DBM_MalrusAquaABIL)
					BLOCK.Value = 1
					MyQST.RegisterForSingleUpdateGameTime(24)
					Debug.Messagebox("You will breath underwater and swim 50% faster for the next 24 hours")
				Endif
			Endif
		Elseif Btn == 4 ; Fairy Cages
			if FairyCages.IsEnabled()
				if DISPLAYCHEST.GetItemCount(DBM_FairyItems) >= 12
					Game.GetPlayer().AddSpell(DBM_MalrusFairyABIL)
					BLOCK.Value = 1
					MyQST.RegisterForSingleUpdateGameTime(24)
					Debug.Messagebox("Spriggans and predator animals will not be hostile toward you for 24 hours.")
				Endif
			Endif
		Elseif Btn == 5 ; next menu
			int Btn2 = MalrusMenu2.Show()
			if Btn2 == 0 	 ; TGCON
				if CowlRef.IsDisabled()				 ; only one that is reversed
					FindMapMarker(DBM_MalrusCodexGCLocations)
					BLOCK.Value = 1
					MyQST.RegisterForSingleUpdateGameTime(24)
					Debug.Messagebox("Map location added to the Ben Erai region")
				Endif
			Elseif Btn2 == 1 ; Wyrmstooth
				if WyrmstoothStuff.IsEnabled()
					FindMapMarker(DBM_MalrusCodexWTLocations)
					BLOCK.Value = 1
					MyQST.RegisterForSingleUpdateGameTime(24)
					Debug.Messagebox("Map location added to the Wyrmstooth region")
				Endif
			Elseif Btn2 == 2 ; Falskaar
				if FalskaarStuff.IsEnabled()
					FindMapMarker(DBM_MalrusCodexFSLocations)
					BLOCK.Value = 1
					MyQST.RegisterForSingleUpdateGameTime(24)
					Debug.Messagebox("Map location added to the Falskaar region")
				Endif
			Elseif Btn2 == 3 ; cancel

			Endif
		Endif		
	Elseif BLOCK.Value == 1
		Debug.Notification("Malrus' Codex can only be used once per day")
	Endif
Endif
EndEvent

Function FindMapmarker(FormList MyList)
	LOCTotal = MyList.GetSize()
if MyList.GetSize() > 0
	LOCNum = Utility.RandomInt(0,LOCtotal)
	O = MyList.GetAt(LOCNum) as ObjectReference

	if !O.IsMapMarkerVisible()
		O.AddToMap()
		MyList.RemoveAddedForm(O)
	Elseif O.IsMapMarkerVisible()
		MyList.RemoveAddedForm(O)
		FindMapMarker(MyList)	
	Endif	
Else
	Debug.Notification("All locations here have been marked")
Endif

EndFunction
