Scriptname DBM_PickyBeaconControl2 extends ObjectReference 
{Revised beacon controller}

;;BEACON CONTROLS
ObjectReference Property EngineLink Auto
{Beacon attached to engine for recieving command}
ObjectReference Property LockedHatch Auto
{Interior hatch that is locked.}
MiscObject Property PickyBeacon Auto
{Beacon base object}
MiscObject Property PickyTransponder Auto
{Transponder base object}
Message Property TravelMessage1 Auto
{First travel selector menu}
Message Property TravelMessage2 Auto
{Second travel selector menu}
Message Property TravelMessage3 Auto
{Third travel selector menu}
Message Property TravelMessage4 Auto
{Forth travel selector menu}
Message Property TravelMessage5 Auto
{Fifth travel selector menu}

;;MAP FLAGS FOR REMOTE ACTIVATION - Interacts with DBM_NavigateScript
ObjectReference Property SolitudeFlag Auto
{Solitude Flag}
ObjectReference Property WhiterunFlag Auto
{Whiterun Flag}
ObjectReference Property MarkarthFlag Auto
{Markarth Flag}
ObjectReference Property FalkreathFlag Auto
{Falkreath Flag}
ObjectReference Property DawnstarFlag Auto
{Dawnstar Flag}
ObjectReference Property RiftenFlag Auto
{Riften Flag}
ObjectReference Property WinterholdFlag Auto
{Winterhold Flag}
ObjectReference Property WindhelmFlag Auto
{Windhelm Flag}
ObjectReference Property RoriksteadFlag Auto
{Rorikstead Flag}
ObjectReference Property HighHrothgarFlag Auto
{HighHrothgar Flag}
ObjectReference Property LabyrinthianFlag Auto
{Labyrinthian Flag}
ObjectReference Property DawnguardFlag Auto
{Fort Dawnguard Flag}
ObjectReference Property VolkiharFlag Auto
{Castle Volkihar Flag}
ObjectReference Property RavenRockFlag Auto
{Raven Rock Flag}
ObjectReference Property TelMithrynFlag Auto
{Tel Mithryn Flag}
ObjectReference Property MiraakTempleFlag Auto
{Temple of Miraak Flag}
ObjectReference Property PalePassFlag Auto
{Pale Pass Flag}
ObjectReference Property DeepholmeFlag Auto
{Deepholme Flag}
ObjectReference Property TopalBaseFlag Auto
{Moonpaths Topal Base Flag}
ObjectReference Property KaragasTowerFlag Auto
{Karagas Tower Flag}

;;FORMLISTS - Interacts with DBM_AirshipScript
ObjectReference Property DBM_AirshipHelm Auto
{Solitude Helm to activate remotely}
FormList Property ShipList Auto
{All ships}
FormList Property CurShip Auto
{Current ship formlist}
FormList Property CurPlayerMark Auto
{Current player marker formlist - check distance from when activating}
GlobalVariable Property ReadyState Auto
{Ready state to lockout additional controls.}

;;VARIABLES
ObjectReference Flag ;Flag to activate remotely
String LocationName ;Name of location for debugs
ObjectReference ActiveShip ;Marker to measure distance with
Int Distance ;Distance variable

Event OnEquipped(Actor akPlayer)
if akPlayer == Game.GetPlayer()
	if !EngineLink.IsDisabled() && ReadyState.Value == 0 || ReadyState.Value == 1 ;The Engine Link Beacon is installed.
		int TravelChoice = TravelMessage1.Show()
			if TravelChoice == 0
				;Close the menu
			elseif TravelChoice == 1 ;Solitude
				ReadyState.Value = 2
				Flag = SolitudeFlag
				Flag.Activate(Game.GetPlayer())
				MoveDevAveza()
			elseif TravelChoice == 2 ;Whiterun
				ReadyState.Value = 2
				Flag = WhiterunFlag
				Flag.Activate(Game.GetPlayer())
				MoveDevAveza()
			elseif TravelChoice == 3 ;Markarth
				ReadyState.Value = 2
				Flag = MarkarthFlag
				Flag.Activate(Game.GetPlayer())
				MoveDevAveza()
			elseif TravelChoice == 4 ;Falkreath
				ReadyState.Value = 2
				Flag = FalkreathFlag
				Flag.Activate(Game.GetPlayer())
				MoveDevAveza()
			elseif TravelChoice == 5 ;Next
				TravelChoice = TravelMessage2.Show() ;second options screen
				if TravelChoice == 0 ;Previous
					TravelChoice = TravelMessage1.Show()
				elseif TravelChoice == 1 ;Dawnstar
					ReadyState.Value = 2
					Flag = DawnstarFlag
					Flag.Activate(Game.GetPlayer())
					MoveDevAveza()
				elseif TravelChoice == 2 ;Riften
					ReadyState.Value = 2
					Flag = RiftenFlag
					Flag.Activate(Game.GetPlayer())
					MoveDevAveza()
				elseif TravelChoice == 3 ;Winterhold
					ReadyState.Value = 2
					Flag = WinterholdFlag
					Flag.Activate(Game.GetPlayer())
					MoveDevAveza()
				elseif TravelChoice == 4 ;Windhelm
					ReadyState.Value = 2
					Flag = WindhelmFlag
					Flag.Activate(Game.GetPlayer())
					MoveDevAveza()
				elseif TravelChoice == 5 ;Next Menu
					TravelChoice = TravelMessage3.Show() ;third options screen
					if TravelChoice == 0 ;Previous
						TravelChoice = TravelMessage2.Show()
					elseif TravelChoice == 1 ;Rorikstead
						ReadyState.Value = 2
						Flag = RoriksteadFlag
						Flag.Activate(Game.GetPlayer())
						MoveDevAveza()
					elseif TravelChoice == 2 ;High Hrothgar
						ReadyState.Value = 2
						Flag = HighHrothgarFlag
						Flag.Activate(Game.GetPlayer())
						MoveDevAveza()
					elseif TravelChoice == 3 ;Labyrinthian
						ReadyState.Value = 2
						Flag = LabyrinthianFlag
						Flag.Activate(Game.GetPlayer())
						MoveDevAveza()
					elseif TravelChoice == 4 ;Fort Dawnguard
						ReadyState.Value = 2
						Flag = DawnguardFlag
						Flag.Activate(Game.GetPlayer())
						MoveDevAveza()
					elseif TravelChoice == 5 ;Next menu
						TravelChoice = TravelMessage4.Show() ;Forth menu
						if TravelChoice == 0 ;Previous
							TravelChoice = TravelMessage3.Show()
						elseif TravelChoice == 1 ;Castle Volkihar
							ReadyState.Value = 2
							Flag = VolkiharFlag
							Flag.Activate(Game.GetPlayer())
							MoveDevAveza()
						elseif TravelChoice == 2 ;Raven Rock
							ReadyState.Value = 2
							Flag = RavenRockFlag
							Flag.Activate(Game.GetPlayer())
							MoveDevAveza()
						elseif TravelChoice == 3 ;Tel Mithryn
							ReadyState.Value = 2
							Flag = TelMithrynFlag
							Flag.Activate(Game.GetPlayer())
							MoveDevAveza()
						elseif TravelChoice == 4 ;Temple of Miraak
							ReadyState.Value = 2
							Flag = MiraakTempleFlag
							Flag.Activate(Game.GetPlayer())
							MoveDevAveza()
						elseif TravelChoice == 5 ;Next menu
							TravelChoice = TravelMessage5.Show() ;Forth menu
							if TravelChoice == 0 ;Previous
								TravelChoice = TravelMessage4.Show()
							elseif TravelChoice == 1 ;Pale Pass
								ReadyState.Value = 2
								Flag = PalePassFlag
								Flag.Activate(Game.GetPlayer())
								MoveDevAveza()
							elseif TravelChoice == 2 ;Deepholme
								ReadyState.Value = 2
								Flag = DeepholmeFlag
								Flag.Activate(Game.GetPlayer())
								MoveDevAveza()
							elseif TravelChoice == 3 ;Topal Base
								ReadyState.Value = 2
								Flag = TopalBaseFlag
								Flag.Activate(Game.GetPlayer())
								MoveDevAveza()
							elseif TravelChoice == 4 ;Exit
								ReadyState.Value = 2
								Flag = DeepholmeFlag
								Flag.Activate(Game.GetPlayer())
								MoveDevAveza()
							elseif TravelChoice == 5 ;Exit
							;
							endif
						endif
					endif
				endif
			endif
	elseif !EngineLink.IsDisabled() && ReadyState.Value >= 2
		GetLocName()
		debug.messagebox("The airship is currently travelling to " + LocationName + ". I should wait before moving it again.")
	elseif akPlayer.GetItemCount(PickyBeacon) > 0 && akPlayer.GetItemCount(PickyTransponder) > 0
		debug.MessageBox("Holding the beacon allows me to communicate with the resonator, this could be useful somehow.")
	else
		debug.MessageBox("When I hold the beacon I can feel a link to another device, but it does nothing.")
	endif
EndIf
EndEvent

Function MoveDevAveza()
	Utility.Wait(0.5) ;Extra Wait to allow flag activation to finish
	GetLocName()
	Int ShipIndex = ShipList.GetSize()
	WHILE ShipIndex
		ShipIndex -= 1
		ActiveShip = ShipList.GetAt(ShipIndex) as ObjectReference
		if !ActiveShip.IsDisabled()
		Distance = Game.GetPlayer().GetDistance(ActiveShip) as Int
		While Distance != 0 && Distance < 1500
			Utility.Wait(2)
			Distance = Game.GetPlayer().GetDistance(ActiveShip) as Int
			;Debug.Trace("DBM Beacon Script - Distance from Airship is " + Distance + "")
			Debug.Notification("I should probably stand clear of the airship as it departs!")
		EndWhile
		endif
	ENDWHILE
	Utility.Wait(0.5) ; pause before activating helm.
	LockedHatch.Enable()
	DBM_AirshipHelm.Activate(Game.GetPlayer())
	Utility.WaitGameTime(2)
	debug.Notification("The Dev Aveza has arrived in " + LocationName + "")
	LockedHatch.Disable()
	ReadyState.Value = 0 ;Reset control ready for reuse
	CurShip.Revert()
	CurPlayerMark.Revert()
EndFunction

Function GetLocName()
LocationName = Flag.GetBaseObject().GetName() ;SKSE Function
EndFunction