Scriptname DBM_PQ_ItemAddScript Extends ReferenceAlias

FormList Property DBM_PQPartsList Auto

MiscObject Property BYOHMaterialStoneBlock Auto
GlobalVariable Property DBM_PQ_Stone  Auto  
GlobalVariable Property DBM_PQ_StoneTOT  Auto  

MiscObject Property IngotDwarven Auto
GlobalVariable Property DBM_PQ_Ingots  Auto  
GlobalVariable Property DBM_PQ_IngotsTOT  Auto

MiscObject Property BYOHMaterialLog Auto
GlobalVariable Property BYOHHouseLogCount  Auto  
GlobalVariable Property DBM_PQ_LogsTOT Auto 

MiscObject Property BYOHMaterialFittingsIron Auto
GlobalVariable Property DBM_PQ_IronFit  Auto  
GlobalVariable Property DBM_PQ_IronFitTOT  Auto   

Quest Property DBM_PlanetariumQST Auto

Int MyObj ;Specified by Function

Event OnInit()
	AddInventoryEventFilter(DBM_PQPartsList)
EndEvent

Event OnItemAdded(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
if DBM_PlanetariumQST.GetStageDone(10) && !DBM_PlanetariumQST.GetStageDone(20)
	if akBaseItem == BYOHMaterialStoneBlock
		MyObj = 10
		StoneCheck()
		
	elseif akBaseItem == IngotDwarven
		MyObj = 11
		IngotCheck()

	elseif akBaseItem == BYOHMaterialLog
		MyObj = 12
		LogCheck()

	elseif akBaseItem == BYOHMaterialFittingsIron
		MyObj = 13
		IronFitCheck()
	endif
elseif DBM_PlanetariumQST.GetStageDone(20)  
	RemoveInventoryEventFilter(DBM_PQPartsList)
endif
EndEvent

Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
if DBM_PlanetariumQST.GetStageDone(10) && !DBM_PlanetariumQST.GetStageDone(20)
	if akBaseItem == BYOHMaterialStoneBlock
		MyObj = 10
		if (Game.GetPlayer().GetItemCount(BYOHMaterialStoneBlock) < DBM_PQ_StoneTOT.GetValue()) && DBM_PlanetariumQST.IsObjectiveCompleted(MyObj) && DBM_PlanetariumQST.IsObjectiveDisplayed(15)
				DBM_PlanetariumQST.SetObjectiveDisplayed(15, false)
		endif
		StoneCheck()
		
	elseif akBaseItem == IngotDwarven
		MyObj = 11
		if (Game.GetPlayer().GetItemCount(IngotDwarven) < DBM_PQ_IngotsTOT.GetValue()) && DBM_PlanetariumQST.IsObjectiveCompleted(MyObj) && DBM_PlanetariumQST.IsObjectiveDisplayed(15)
				DBM_PlanetariumQST.SetObjectiveDisplayed(15, false)
		endif
		IngotCheck()

	elseif akBaseItem == BYOHMaterialLog
		MyObj = 12
		if (BYOHHouseLogCount.GetValue() < DBM_PQ_LogsTOT.GetValue()) && DBM_PlanetariumQST.IsObjectiveCompleted(MyObj) && DBM_PlanetariumQST.IsObjectiveDisplayed(15)
				DBM_PlanetariumQST.SetObjectiveDisplayed(15, false)
		endif
		LogCheck()

	elseif akBaseItem == BYOHMaterialFittingsIron
		MyObj = 23
		if Game.GetPlayer().GetItemCount(BYOHMaterialFittingsIron) < DBM_PQ_IronFitTOT.GetValue() && DBM_PlanetariumQST.IsObjectiveCompleted(MyObj)
			DBM_PlanetariumQST.SetObjectiveCompleted(MyObj, False)
		endif
		IronFitCheck()
	endif
elseif DBM_PlanetariumQST.GetStageDone(20)
	RemoveInventoryEventFilter(DBM_PQPartsList)
endif
EndEvent

Function StoneCheck()
		if Game.GetPlayer().GetItemCount(BYOHMaterialStoneBlock) >= DBM_PQ_StoneTOT.GetValue()
			DBM_PQ_Stone.SetValue(DBM_PQ_StoneTOT.GetValue())
		else
			DBM_PQ_Stone.SetValue(Game.GetPlayer().GetItemCount(BYOHMaterialStoneBlock))
		endif
		DBM_PlanetariumQST.UpdateCurrentInstanceGlobal(DBM_PQ_Stone)
		DBM_PlanetariumQST.SetObjectiveDisplayed(MyObj, 1, 1)
		if DBM_PQ_Stone.GetValue() == DBM_PQ_StoneTOT.GetValue()
			DBM_PlanetariumQST.SetObjectiveCompleted(MyObj, True)
			DBM_PlanetariumQST.SetStage(11)
		elseif DBM_PlanetariumQST.IsObjectiveCompleted(MyObj) && Game.GetPlayer().GetItemCount(BYOHMaterialStoneBlock) < DBM_PQ_StoneTOT.GetValue()
			DBM_PlanetariumQST.SetObjectiveCompleted(MyObj, False)
		endif
EndFunction

Function IngotCheck()
		if Game.GetPlayer().GetItemCount(IngotDwarven) >= DBM_PQ_IngotsTOT.GetValue()
			DBM_PQ_Ingots.SetValue(DBM_PQ_IngotsTOT.GetValue())
		else
			DBM_PQ_Ingots.SetValue(Game.GetPlayer().GetItemCount(IngotDwarven))
		endif
		DBM_PlanetariumQST.UpdateCurrentInstanceGlobal(DBM_PQ_Ingots)
		DBM_PlanetariumQST.SetObjectiveDisplayed(MyObj, 1, 1)
		if DBM_PQ_Ingots.GetValue() == DBM_PQ_IngotsTOT.GetValue()
			DBM_PlanetariumQST.SetObjectiveCompleted(MyObj)
			DBM_PlanetariumQST.SetStage(11)
		elseif DBM_PlanetariumQST.IsObjectiveCompleted(MyObj) && Game.GetPlayer().GetItemCount(IngotDwarven) < DBM_PQ_IngotsTOT.GetValue()
			DBM_PlanetariumQST.SetObjectiveCompleted(MyObj, False)
		endif
EndFunction

Function LogCheck()
		DBM_PlanetariumQST.UpdateCurrentInstanceGlobal(BYOHHouseLogCount)
		DBM_PlanetariumQST.SetObjectiveDisplayed(MyObj, 1, 1)
		if BYOHHouseLogCount.GetValue() >= DBM_PQ_LogsTOT.GetValue()
			DBM_PlanetariumQST.SetObjectiveCompleted(MyObj)
			DBM_PlanetariumQST.SetStage(11)
		elseif BYOHHouseLogCount.GetValue() < DBM_PQ_LogsTOT.GetValue() && DBM_PlanetariumQST.IsObjectiveCompleted(MyObj)
			DBM_PlanetariumQST.SetObjectiveCompleted(MyObj, False)
		endif
EndFunction

Function IronFitCheck()
		if Game.GetPlayer().GetItemCount(BYOHMaterialFittingsIron) >= DBM_PQ_IronFitTOT.GetValue()
			DBM_PQ_IronFit.SetValue(DBM_PQ_IronFitTOT.GetValue())
		else
			DBM_PQ_IronFit.SetValue(Game.GetPlayer().GetItemCount(BYOHMaterialFittingsIron))
		endif
		DBM_PlanetariumQST.UpdateCurrentInstanceGlobal(DBM_PQ_IronFit)
		DBM_PlanetariumQST.SetObjectiveDisplayed(MyObj, 1, 1)
		if DBM_PQ_IronFit.GetValue() == DBM_PQ_IronFitTOT.GetValue()
			DBM_PlanetariumQST.SetObjectiveCompleted(MyObj)
			DBM_PlanetariumQST.SetStage(11)
		elseif DBM_PlanetariumQST.IsObjectiveCompleted(MyObj) && Game.GetPlayer().GetItemCount(BYOHMaterialFittingsIron) < DBM_PQ_IronFitTOT.GetValue()
			DBM_PlanetariumQST.SetObjectiveCompleted(MyObj, False)
		endif
EndFunction
