Scriptname DBM_RadiantFunctions extends Quest  
{Control various functions and updates called in Radiant Handler Quest}

Quest Property DBM_RadiantHandler Auto

ObjectReference Property DISPLAYCHEST Auto
ObjectReference Property DISPLAYCHEST2 Auto
ObjectReference Property JewelryCabinet Auto
FormList Property DBM_RadiantRelicBase  Auto 

FormList Property DBM_RadiantRelicList  Auto  
{Master list of radiant-safe relics}
FormList Property DBM_RadiantChoice Auto  
{Selected radiant relic}
Quest Property DBM_RadiantRelicQST Auto
GlobalVariable Property RadiantRelic Auto
GlobalVariable Property RadiantFirstRun Auto

Function RerollRelic()
int Attempts = 0
while RadiantFirstRun.Value == 1 || DBM_RadiantRelicQST.IsRunning() && Attempts < 3
	Utility.Wait(0.5)
	debug.notification("Waiting for RelicQST to be stopped.")
	Attempts += 1
endwhile
if !DBM_RadiantRelicQST.IsRunning()
	DBM_RadiantChoice.Revert()
	int Listsize = DBM_RadiantRelicList.GetSize()
	int Random = Utility.RandomInt(0, (ListSize - 1))
	;debug.notification("DBM_RadiantRelicList random record is " + Random + "/" + ListSize + ".")
	Form FA = DBM_RadiantRelicList.GetAt(Random) as Form
	DBM_RadiantChoice.AddForm(FA)
EndIf
EndFunction

Event OnUpdateGameTime()
	if RadiantRelic.Value == -1 || DBM_RadiantRelicList.GetSize() > 0 ;Radiant Relic quest was completed so delay is required.
		RadiantRelic.Value += 1 ;set back to 0
		UnregisterForUpdateGameTime()
	elseif DBM_RadiantRelicList.GetSize() == 0
		UnregisterForUpdateGameTime()
		Debug.Trace("DBM Finders Keepers Quest has shut down because all relics have been located.")
	endif
EndEvent

Function StartupTasks() ;Previous OnInit 
	RadiantRelic.SetValue(0)
	if RadiantFirstRun.Value == 1
	RadiantFirstRun.SetValue(0)
	DBM_RadiantChoice.Revert()
	DBM_RadiantRelicList.Revert()
	int Index = DBM_RadiantRelicBase.GetSize()
	While Index
		Index -= 1
		Form FB = DBM_RadiantRelicBase.GetAt(Index)
		if DISPLAYCHEST.GetItemCount(FB) == 0 && Game.GetPlayer().GetItemCount(FB) == 0 && DISPLAYCHEST2.GetItemCount(FB) == 0 && JewelryCabinet.GetItemCount(FB) == 0
			DBM_RadiantRelicList.AddForm(FB)
		Endif
	EndWhile
	int Listsize = DBM_RadiantRelicList.GetSize()
	debug.trace("DBM_RadiantRelicList has a size of " + Listsize + " after firstrun.")
	(DBM_RadiantHandler as DBM_RadiantAddons).ExtendRelics()
	EndIf
EndFunction