Scriptname DBM_StuffSortScript extends ObjectReference  

Keyword Property ArmorHeavy Auto
Keyword Property ArmorLight Auto
Keyword Property ArmorClothing Auto
Keyword Property ArmorShield Auto
Keyword Property ArmorJewelry Auto

Keyword Property WeapTypeSword Auto
Keyword Property WeapTypeGreatsword Auto
Keyword Property WeapTypeWaraxe Auto
Keyword Property WeapTypeBattleaxe Auto
Keyword Property WeapTypeMace Auto
Keyword Property WeapTypeWarhammer Auto
Keyword Property WeapTypeBow Auto
Keyword Property WeapTypeDagger Auto
Keyword Property WeapTypeStaff Auto

Keyword Property VendorItemArrow Auto
Keyword Property VendorItemClutter Auto
Keyword Property VendorItemNote Auto
Keyword Property VendorItemJournal Auto
Keyword Property VendorItemRecipe Auto
Keyword Property VendorItemBook Auto
Keyword Property VendorItemFateCards Auto
Keyword Property VendorItemScroll Auto

Keyword Property VendorItemFireword Auto

Keyword Property VendorItemKey Auto

Keyword Property VendorItemIngredient Auto
Keyword Property VendorItemAnimalHide Auto
Keyword Property VendorItemAnimalPart Auto
Keyword Property VendorItemGem Auto
Keyword Property VendorItemOreIngot Auto
Keyword Property VendorItemPotion Auto
Keyword Property VendorItemPoison Auto
Keyword Property VendorItemSoulGem Auto
Keyword Property VendorItemFood Auto
Keyword Property VendorItemFoodRaw Auto

ObjectReference  Property HeavyArmorSortChest Auto
ObjectReference  Property LightArmorSortChest Auto
ObjectReference  Property ClothingArmorSortChest Auto
ObjectReference  Property ShieldSortChest Auto
ObjectReference  Property JewelrySortChest Auto

ObjectReference  Property OneHSwordSortChest Auto
ObjectReference  Property TwoHSwordSortChest Auto
ObjectReference  Property OneHAxeSortChest Auto
ObjectReference  Property TwoHAxeSortChest Auto
ObjectReference  Property OneHMaceSortChest Auto
ObjectReference  Property TwoHMaceSortChest Auto
ObjectReference  Property StaffSortChest Auto

ObjectReference  Property BowSortChest Auto
ObjectReference  Property AmmoSortChest Auto
ObjectReference  Property DaggerSortChest Auto

ObjectReference  Property ClutterSortChest Auto
ObjectReference  Property NoteSortChest Auto
ObjectReference  Property JournalSortChest Auto
ObjectReference  Property RecipeSortChest Auto
ObjectReference  Property BookSortChest Auto
ObjectReference  Property FirewoodSortChest Auto

ObjectReference  Property KeySortChest Auto

ObjectReference Property GoldStore Auto
ObjectReference Property IngredientStore Auto
ObjectReference Property LeatherStore Auto
ObjectReference Property GemStore Auto
ObjectReference Property IngotOreStore Auto
ObjectReference Property PotionStore Auto
ObjectReference Property PoisonStore Auto
ObjectReference Property SoulGemStore Auto
ObjectReference Property FateCardsStore Auto
ObjectReference Property ScrollStore Auto
ObjectReference Property FoodStore Auto
ObjectReference Property FoodStoreRaw Auto
ObjectReference Property LiquorStore Auto
ObjectReference Property MaterialStore Auto

FormList Property IngotsNOre Auto
FormList Property GemList Auto
FormList Property IngredientList Auto
FormList Property PotionsList Auto
FormList Property PoisonList Auto
FormList Property Soulgemslist Auto
FormList Property FoodListRaw Auto
FormList Property FoodListCooked Auto
FormList Property LiquorList Auto
FormList Property ScrollsList Auto
FormList Property LeatherList Auto
FormList Property MiscList Auto
FormList Property MaterialList Auto

DBM_SupplyRecordScript Property R_OreStore Auto
DBM_SupplyRecordScript Property R_GemStore Auto
DBM_SupplyRecordScript Property R_IngrStore Auto
DBM_SupplyRecordScript Property R_MatsStore Auto
DBM_SupplyRecordScript Property R_PotsStore Auto
DBM_SupplyRecordScript Property R_PoisStore Auto
DBM_SupplyRecordScript Property R_SGStore Auto
DBM_SupplyRecordScript Property R_RawStore Auto
DBM_SupplyRecordScript Property R_CookedStore Auto
DBM_SupplyRecordScript Property R_LiquorStore Auto
DBM_SupplyRecordScript Property R_ScrollStore Auto
DBM_SupplyRecordScript Property R_LeatherStore Auto
DBM_SupplyRecordScript Property R_Recipestore Auto
DBM_SupplyRecordScript Property R_FirewoodStore Auto

MiscObject Property Gold001 Auto

Event OnActivate(ObjectReference akActionREF)
	if akActionREF == Game.GetPlayer()
		Utility.Wait(2)
		Self.BlockActivation(true)
		R_OreStore.RecordSupplies()
		R_GemStore.RecordSupplies()
		R_IngrStore.RecordSupplies()
		R_MatsStore.RecordSupplies()
		R_PotsStore.RecordSupplies()
		R_PoisStore.RecordSupplies()
		R_SGStore.RecordSupplies()
		R_RawStore.RecordSupplies()
		R_CookedStore.RecordSupplies()
		R_LiquorStore.RecordSupplies()
		R_ScrollStore.RecordSupplies()
		R_LeatherStore.RecordSupplies()
		R_Recipestore.RecordSupplies()
		R_FirewoodStore.RecordSupplies()
		Self.BlockActivation(false)
	Endif
EndEvent


Event OnItemAdded(Form akBaseItem, Int aiItemCount, ObjectReference akFormReference, ObjectReference akSourceContainer)
	If akBaseItem == Gold001
		Self.Removeitem(akBaseItem, aiItemCount, false, GoldStore)
	elseif MaterialList.HasForm(akBaseItem)
		Self.RemoveItem(akBaseItem, aiItemCount, false, MaterialStore)
	elseif MiscList.HasForm(akBaseItem)
		Self.Removeitem(akBaseItem, aiItemCount, false, ClutterSortChest)
	elseif IngredientList.HasForm(akBaseItem)
		Self.Removeitem(akBaseItem, aiItemCount, false, IngredientStore)
	elseif LeatherList.HasForm(akBaseItem)
		Self.Removeitem(akBaseItem, aiItemCount, false, LeatherStore)
	elseif IngotsNOre.HasForm(akBaseItem)
		Self.Removeitem(akBaseItem, aiItemCount, false, IngotOreStore)
	elseif GemList.HasForm(akBaseItem)
		Self.Removeitem(akBaseItem, aiItemCount, false, GemStore)
	elseif PoisonList.HasForm(akBaseItem)
		Self.Removeitem(akBaseItem, aiItemCount, false, PoisonStore)
	elseif PotionsList.HasForm(akBaseItem)
		Self.Removeitem(akBaseItem, aiItemCount, false, PotionStore)
	elseif SoulGemsList.HasForm(akBaseItem)
		Self.Removeitem(akBaseItem, aiItemCount, false, SoulGemStore)
	elseif ScrollsList.HasForm(akBaseItem)
		Self.Removeitem(akBaseItem, aiItemCount, false, ScrollStore)
	elseif akBaseItem.HasKeyword(VendorItemFood)
		Self.Removeitem(akBaseItem, aiItemCount, false, FoodStore)
	elseif akBaseItem.HasKeyword(VendorItemFoodRaw)
		Self.Removeitem(akBaseItem, aiItemCount, false, FoodStoreRaw)
	elseif akBaseItem.HasKeyword(VendorItemFoodRaw)
		Self.Removeitem(akBaseItem, aiItemCount, false, FoodStoreRaw)


	elseif akBaseItem.HasKeyword(ArmorHeavy)
		Self.Removeitem(akBaseItem, aiItemCount, false, HeavyArmorSortChest)
	elseif akBaseItem.HasKeyword(ArmorLight)
		Self.Removeitem(akBaseItem, aiItemCount, false, LightArmorSortChest)
	elseif akBaseItem.HasKeyword(ArmorClothing)
		Self.Removeitem(akBaseItem, aiItemCount, false, ClothingArmorSortChest)
	elseif akBaseItem.HasKeyword(WeapTypeSword)
		Self.Removeitem(akBaseItem, aiItemCount, false, OneHSwordSortChest)
	elseif akBaseItem.HasKeyword(WeapTypeGreatsword)
		Self.Removeitem(akBaseItem, aiItemCount, false, TwoHSwordSortChest)
	elseif akBaseItem.HasKeyword(WeapTypeWarAxe)
		Self.Removeitem(akBaseItem, aiItemCount, false, OneHAxeSortChest)
	elseif akBaseItem.HasKeyword(WeapTypeBattleaxe)
		Self.Removeitem(akBaseItem, aiItemCount, false, TwoHAxeSortChest)
	elseif akBaseItem.HasKeyword(WeapTypeMace)
		Self.Removeitem(akBaseItem, aiItemCount, false, OneHMaceSortChest)
	elseif akBaseItem.HasKeyword(WeapTypeWarhammer)
		Self.Removeitem(akBaseItem, aiItemCount, false, TwoHMaceSortChest)
	elseif akBaseItem.HasKeyword(WeapTypeBow)
		Self.Removeitem(akBaseItem, aiItemCount, false, BowSortChest)
	elseif akBaseItem.HasKeyword(WeapTypeDagger)
		Self.Removeitem(akBaseItem, aiItemCount, false, DaggerSortChest)
	elseif akBaseItem.HasKeyword(VendorItemArrow)
		Self.Removeitem(akBaseItem, aiItemCount, false, AmmoSortChest)
	elseif akBaseItem.HasKeyword(VendorItemFateCards)
		Self.Removeitem(akBaseItem, aiItemCount, false, FateCardsStore)
	elseif akBaseItem.HasKeyword(VendorItemFireword)
		Self.Removeitem(akBaseItem, aiItemCount, false, FirewoodSortChest)
	elseif akBaseItem.HasKeyword(VendorItemClutter)
		Self.Removeitem(akBaseItem, aiItemCount, false, ClutterSortChest)
	elseif akBaseItem.HasKeyword(ArmorShield)
		Self.Removeitem(akBaseItem, aiItemCount, false, ShieldSortChest)
	elseif akBaseItem.HasKeyword(ArmorJewelry)
		Self.Removeitem(akBaseItem, aiItemCount, false, JewelrySortChest)
	elseif akBaseItem.HasKeyword(WeapTypeStaff)
		Self.Removeitem(akBaseItem, aiItemCount, false, StaffSortChest)
	elseif akBaseItem.HasKeyword(VendorItemNote)
		Self.Removeitem(akBaseItem, aiItemCount, false, NoteSortChest)
	elseif akBaseItem.HasKeyword(VendorItemJournal)
		Self.Removeitem(akBaseItem, aiItemCount, false, JournalSortChest)
	elseif akBaseItem.HasKeyword(VendorItemRecipe)
		Self.Removeitem(akBaseItem, aiItemCount, false, RecipeSortChest)
	elseif akBaseItem.HasKeyword(VendorItemBook)
		Self.Removeitem(akBaseItem, aiItemCount, false, BookSortChest)
	elseif akBaseItem.HasKeyword(VendorItemKey)
		Self.Removeitem(akBaseItem, aiItemCount, false, KeySortChest)
	elseif akBaseItem.HasKeyword(VendorItemIngredient)
		Self.Removeitem(akBaseItem, aiItemCount, false, IngredientStore)
	elseif akBaseItem.HasKeyword(VendorItemAnimalPart)
		Self.Removeitem(akBaseItem, aiItemCount, false, LeatherStore)
	elseif akBaseItem.HasKeyword(VendorItemOreIngot)
		Self.Removeitem(akBaseItem, aiItemCount, false, IngotOreStore)
	elseif akBaseItem.HasKeyword(VendorItemGem)
		Self.Removeitem(akBaseItem, aiItemCount, false, GemStore)
	elseif akBaseItem.HasKeyword(VendorItemPoison)
		Self.Removeitem(akBaseItem, aiItemCount, false, PoisonStore)
	elseif akBaseItem.HasKeyword(VendorItemPotion)
		Self.Removeitem(akBaseItem, aiItemCount, false, PotionStore)
	elseif akBaseItem.HasKeyword(VendorItemSoulGem)
		Self.Removeitem(akBaseItem, aiItemCount, false, SoulGemStore)
	elseif akBaseItem.HasKeyword(VendorItemScroll)
		Self.Removeitem(akBaseItem, aiItemCount, false, ScrollStore)
	elseif FoodListCooked.HasForm(akBaseItem)
		Self.Removeitem(akBaseItem, aiItemCount, false, FoodStore)
	elseif FoodListRaw.HasForm(akBaseItem)
		Self.Removeitem(akBaseItem, aiItemCount, false, FoodStoreRaw)
	elseif LiquorList.HasForm(akBaseItem)
		Self.Removeitem(akBaseItem, aiItemCount, false, LiquorStore)
	EndIf
EndEvent
