Scriptname DBM_TonalStaffGemScript extends ObjectReference  

MiscObject Property GemSapphireFlawless Auto
MiscObject Property GemRubyFlawless Auto
MiscObject Property GemDiamondFlawless Auto
MiscObject Property GemEmeraldFlawless Auto
MiscObject Property GemAmethystFlawless Auto
MiscObject Property GemGarnetFlawless Auto

ObjectReference Property HoldingBox Auto

Message Property MyMSG Auto
Message Property MyMSG2 Auto

Weapon Property DBM_TonalStaff Auto
Weapon Property DBM_TonalStaffGemA Auto
Weapon Property DBM_TonalStaffGemD Auto
Weapon Property DBM_TonalStaffGemE Auto
Weapon Property DBM_TonalStaffGemG Auto
Weapon Property DBM_TonalStaffGemR Auto
Weapon Property DBM_TonalStaffGemS Auto

Spell Property DBM_TonalGemSPELA Auto
Spell Property DBM_TonalGemSPELD Auto
Spell Property DBM_TonalGemSPELE Auto
Spell Property DBM_TonalGemSPELG Auto
Spell Property DBM_TonalGemSPELR Auto
Spell Property DBM_TonalGemSPELS Auto

FormList Property DBM_TonalStaffList Auto

Weapon CurrentStaff ;Currently equipped variant.
Spell CurrentSpell ;Current magic effect.

Event OnEquipped(Actor akActor)

if Game.GetPlayer().GetItemCount(DBM_TonalStaffList) >= 1

	int MyBTN = MyMSG.Show()

	If MyBTN == 0 ;		socket a gem
		int MyBtn2 = MyMSG2.Show()
			if MyBtn2 == 0 ; Sapphire
				StaffSwap(GemSapphireFlawless, DBM_TonalStaffGemS, DBM_TonalGemSPELS)				
			ElseIf MyBtn2 == 1 ; Ruby
				StaffSwap(GemRubyFlawless, DBM_TonalStaffGemR, DBM_TonalGemSPELR)
			ElseIf MyBtn2 == 2 ; Diamond
				StaffSwap(GemDiamondFlawless, DBM_TonalStaffGemD, DBM_TonalGemSPELD)
			ElseIf MyBtn2 == 3 ; Emerald
				StaffSwap(GemEmeraldFlawless, DBM_TonalStaffGemE, DBM_TonalGemSPELE)
			ElseIf MyBtn2 == 4 ; Amethyst
				StaffSwap(GemAmethystFlawless, DBM_TonalStaffGemA, DBM_TonalGemSPELA)
			ElseIf MyBtn2 == 5 ; Garnet
				StaffSwap(GemGarnetFlawless, DBM_TonalStaffGemG, DBM_TonalGemSPELG)
			ElseIf MyBTN2 == 6 ;		Don't socket
				StaffSwap(NONE, DBM_TonalStaff, NONE)
			Endif
	EndIf
Elseif Game.GetPlayer().GetItemCount(DBM_TonalStaffList) < 1
	Debug.Notification("You must have the Tonal Staff of Karagas to use the gem socket tool kit")
Endif
EndEvent

Function StaffSwap (MiscObject akNewGem, Weapon akNewStaff, Spell akResist)
	Bool EquipMe
	Actor PLYR = Game.GetPlayer()
	if PLYR.IsEquipped(DBM_TonalStaffList)
		EquipMe = True
	else
		EquipMe = False
	endif
	HoldingBox.RemoveAllItems(akTransferTo = PLYR)
	PLYR.RemoveItem(DBM_TonalStaffList, 1, True)
	PLYR.RemoveSpell(CurrentSpell)
	if akNewGem != NONE
		PLYR.RemoveItem(akNewGem, 1, False, HoldingBox)
	endif
	PLYR.AddItem(akNewStaff, 1, true)
	CurrentStaff = akNewStaff
	CurrentSpell = akResist
	if EquipMe
		PLYR.EquipItem(akNewStaff)
		PLYR.AddSpell(akResist)
	endif
	Debug.MessageBox("You use the Gem Socket Kit on the Tonal Staff of Karagas")
EndFunction