Scriptname DBM_BYOHPlanetariumScript extends ObjectReference  
{Controller for build objects in the planetarium}

Quest Property PQuest Auto
{Planetarium Quest}

Bool Property bLastItem Auto
{Is this the final build object? If TRUE advance quest}
Bool Property bWALLMARKER Auto
{Do we need to start the hammering animation?}

ObjectReference Property OEnable1 Auto
{Object to enable}
ObjectReference Property OEnable2 Auto
{Object to enable}
ObjectReference Property OEnable3 Auto
{Object to enable}

ObjectReference Property ODisable1 Auto
{Object to disable}
ObjectReference Property ODisable2 Auto
{Object to disable}
ObjectReference Property ODisable3 Auto
{Object to disable}

ObjectReference Property FadeInMark Auto
{Where shall we move the player after the build.}

MiscObject Property DummyObject Auto
{Object to remove on completing action.}

ImagespaceModifier Property AzuraFadeToBlack Auto
ImagespaceModifier Property FadeToBlackBackIMod Auto
ImagespaceModifier Property FadeToBlackHoldIMod Auto
GlobalVariable Property GameHour Auto

Int Property HoursPassed Auto
{How long will building it take?}

Event OnContainerChanged(ObjectReference akNew, ObjectReference akOld)
	if akNew == Game.GetPlayer()
	FadeOut()
	akNew.RemoveItem(DummyObject,1,1)
		if OEnable1
			OEnable1.Enable()
		endif
		if OEnable2
			OEnable2.Enable()
		endif
		if OEnable3
			OEnable3.Enable()
		endif
		if ODisable1
			ODisable1.Disable()
		endif
		if ODisable2
			ODisable2.Disable()
		endif
		if ODisable3
			ODisable3.Disable()
		endif
		akNew.RemoveItem(DummyObject,1,1)
	If FadeInMark
		Game.ForceThirdPerson()
		akNew.Moveto(FadeinMark)
	EndIf
	Utility.Wait(2)
	FadeIn()
	EndIf
EndEvent

Function FadeOut()
	Game.ForceThirdPerson()
	Debug.SendAnimationEvent(Game.GetPlayer(), "IdleForceDefaultState")
	Game.DisablePlayerControls(true, true, true, true, true, false, true, true)
	Utility.Wait(2)
	Game.FadeOutGame(False,True,50, 1)
	AzuraFadeToBlack.Apply()
	Gamehour.Value += HoursPassed
EndFunction

Function FadeIn()
	Game.FadeOutGame(False,True,0.1, 0.1)	
	AzuraFadeToBlack.PopTo(FadeToBlackBackImod)
	If bWALLMARKER
			Debug.SendAnimationEvent(Game.GetPlayer(), "IdleHammerWallEnterInstant")
	EndIf
	Utility.Wait(2)
	Debug.MessageBox("You spend " + HoursPassed + " hours working on the Planetarium.")
	Utility.Wait(2)
	Debug.SendAnimationEvent(Game.GetPlayer(), "IdleForceDefaultState")
	Game.EnablePlayerControls()
	if bLastItem
			PQuest.SetStage(35)
		endif
EndFunction