Scriptname DBM_GuideBookAliasScript extends ReferenceAlias  
{Revised version of DBM_CuratorGuideScript to avoid the need for 3 different books.}

;;TRAVEL MESSAGES
Message Property DBM_GuideMSG Auto
{Main Menu - Find Auryen, Travel, Read}
Message Property DBM_GuideMSG1 Auto
{Travel to HOH, Upper Gallery, Library, SafeHouse}
Message Property DBM_GuideMSG2 Auto
{Travel to Daedric Galley, HOLE, Natural Science, Hall of Oddities}
Message Property DBM_GuideMSG3 Auto
{Travel to Armoury main, south, west, east, lower}
Message Property DBM_GuideMSG4 Auto
{Travel to Art Gallery, Dragonborn Hall}
Message Property DBM_GuideMSG4A Auto
{As MSG4 but with Guild House}
Message Property DBM_GuideMSG4B Auto
{As MSG 4 but with Guild House and Planetarium}

;;COC LOCATIONS
ObjectReference Property COC01 Auto
ObjectReference Property COC02 Auto
ObjectReference Property COC03 Auto
ObjectReference Property COC04 Auto
ObjectReference Property COC05 Auto
ObjectReference Property COC06 Auto
ObjectReference Property COC07 Auto
ObjectReference Property COC08 Auto
ObjectReference Property COC09 Auto
ObjectReference Property COC10 Auto
ObjectReference Property COC11 Auto
ObjectReference Property COC12 Auto
ObjectReference Property COC13 Auto
ObjectReference Property COC14 Auto
ObjectReference Property COC15 Auto
ObjectReference Property COC16 Auto
ObjectReference Property COC17 Auto
ObjectReference Property COC18 Auto

Keyword Property DBM_GuideBookTravel Auto
{Keyword to replace location reference}

Quest Property DBM_GuideBookHandler Auto
Quest Property DBM_MuseumHeist Auto
Quest Property DBM_hauntedMuseumQuest Auto
Quest Property DBM_ExplorerGuildHouse Auto
Quest Property DBM_PlanetariumQuest Auto

Globalvariable Property SafehouseAccess Auto
{Global that blocks safehouse access.}

Actor Property DBM_Auryen Auto

;;VARIABLES
Bool FirstUse = TRUE
Bool GuildHouseTravel
Bool PlanetariumTravel

Event OnRead()
	DBM_GuideBookHandler.SetStage(10)
	
if (Game.GetPlayer().GetCurrentLocation()).HasKeyword(DBM_GuideBookTravel)

	if DBM_HauntedMuseumQuest.GetStage() >= 5 && DBM_HauntedMuseumQuest.GetStage() < 110
		Debug.Notification("Something is amiss at the Museum")
	Elseif DBM_MuseumHeist.GetStage() >= 5 && DBM_MuseumHeist.GetStage() < 60
		Debug.Notification("Something is amiss at the Museum")
	Else
		If Firstuse
			debug.messagebox("This guide will not only tell you all you need to know about how to use the museum, but will also allow you to quickly navigate to your chosen area, locate the curator, and keep track of your total museum display count. Just re-read the book to trigger the menu")
			FirstUse = FALSE
		Else
			if !GuildHouseTravel && DBM_ExplorerGuildHouse.IsCompleted() ;Unlock Guild House?
				GuildHouseTravel = TRUE
				DBM_GuideMSG4 = DBM_GuideMSG4A
				Debug.MessageBox("You can now use the Curator's Guide to travel to the Explorer's Guildhouse.")
			Endif
			if !PlanetariumTravel && (DBM_PlanetariumQuest.GetStage() > 20 || DBM_PlanetariumQuest.IsCompleted()) ;Unlock Planetarium?
				PlanetariumTravel = TRUE
				DBM_GuideMSG4 = DBM_GuideMSG4B
				Debug.MessageBox("You can now use the Curator's Guide to travel to the Planetarium.")
			EndIf
			Utility.WaitMenuMode(2)
		Endif
		
		Int BookBTN = DBM_GuideMSG.Show()
			if BookBTN == 0 ; find auryen
				if DBM_Auryen.IsEnabled()
					String AuryenCell = DBM_Auryen.GetParentCell().getName() ;SKSE
					debug.messagebox("Auryen is in the " + AuryenCell + " ")
				Else 
					debug.messagebox("Auryen is currently out of the museum.")
				Endif
			Elseif BookBTN == 1 ; travel
	
				int SortBtn = DBM_GuideMSG1.show()
					if SortBtn == 0
						; Hall of heroes
						if IsNewCell(COC01) == TRUE
							Game.GetPlayer().MoveTo(COC01)
						endif
					elseif SortBtn == 1
						; upper gallery
						if IsNewCell(COC15) == TRUE
							Game.GetPlayer().MoveTo(COC15)
						endif
					elseif SortBtn == 2
						; Library
						if IsNewCell(COC14) == TRUE
							Game.GetPlayer().MoveTo(COC14)
						endif
					elseif SortBtn == 3
						; safehouse
						if SafehouseAccess.Value == 0
							Debug.Notification("You do not yet have access to the safehouse")
						Elseif SafehouseAccess.Value == 1 && IsNewCell(COC07) == TRUE
							Game.GetPlayer().MoveTo(COC07)
						EndIf
					elseif SortBtn == 4 ; next

							int SortBtn2 = DBM_GuideMSG2.show()
							if SortBtn2 == 0
								; Daedric						
								if IsNewCell(COC02) == TRUE
									Game.GetPlayer().MoveTo(COC02)
								endif
							elseif SortBtn2 == 1
								; HOLE
								if IsNewCell(COC03) == TRUE
									Game.GetPlayer().MoveTo(COC03)
								endif
							elseif SortBtn2 == 2
								; Natural science
								if IsNewCell(COC04) == TRUE
									Game.GetPlayer().MoveTo(COC04)
								endif
							elseif SortBtn2 == 3
								; Oddities
								if IsNewCell(COC06) == TRUE
									Game.GetPlayer().MoveTo(COC06)
								endif
							elseif SortBtn2 == 4 ; next	


								int SortBtn3 = DBM_GuideMSG3.show()
								if SortBtn3 == 0
									; Armory main						
									if IsNewCell(COC08) == TRUE
										Game.GetPlayer().MoveTo(COC08)
									EndIf
								elseif SortBtn3 == 1
									; south					
									if IsNewCell(COC10) == TRUE
										Game.GetPlayer().MoveTo(COC10)
									endif
								elseif SortBtn3 == 2
									; east
									if IsNewCell(COC09) == TRUE
										Game.GetPlayer().MoveTo(COC09)
									endif
								elseif SortBtn3 == 3
									; West
									if IsNewCell(COC11) == TRUE
										Game.GetPlayer().MoveTo(COC11)
									endif
								elseif SortBtn3 == 4
									; Lower
									if IsNewCell(COC16) == TRUE
										Game.GetPlayer().MoveTo(COC16)
									endif
								elseif SortBtn3 == 5 ; next

										int SortBtn4 = DBM_GuideMSG4.show()
										if SortBtn4 == 0
											; cultural arts
											if IsNewCell(COC17) == TRUE
												Game.GetPlayer().MoveTo(COC17)
											endif
										elseif SortBtn4 == 1
											; Dragonborn Hall
											if IsNewCell(COC18) == TRUE
												Game.GetPlayer().MoveTo(COC18)
											endif
										elseif SortBtn4 == 2
											; guild
											if GuildHouseTravel && IsNewCell(COC12) == TRUE
												Game.GetPlayer().MoveTo(COC12)
											else
												; Cancel
											endif
										elseif SortBtn4 == 3
											; planetarium
											if PlanetariumTravel && IsNewCell(COC13) == TRUE
												Game.GetPlayer().MoveTo(COC13)
											else
												; Cancel
											endif
										elseif SortBtn4 == 4
											; Cancel
										
										endif
								endif
							endif
					endif
			Elseif BookBTN == 2 ; read/cancel
			Endif
	Endif
Else
	Debug.Notification("You must be inside a museum area")
Endif

endevent

Event OnContainerChanged(ObjectReference akNewContainer, ObjectReference akOldContainer)
	FirstUse = TRUE
EndEvent

Bool Function IsNewCell(ObjectReference akMarker)
	If Game.GetPlayer().GetParentCell() == akMarker.GetParentCell()
		Debug.Messagebox("It would be silly of me to travel to a room I'm already in.")
		Return False
	Else
		Return True
	Endif
EndFunction