Scriptname DBM_JewelryDisplayScript extends ObjectReference  

Armor M
ObjectReference O
GlobalVariable Property DBM_DisplayMax Auto
vdbm_datamanager Property DataMGR Auto
FormList Property DBM_JewelryUnique Auto
int index


Auto State Waiting

Event OnActivate(ObjectReference akActionRef)
	BlockActivation()
	GoToState("Sorting")
	Utility.Wait(1.0)

	ResetDisplay()
	UpdateDisplay()
	RefreshCount()
	
	BlockActivation(False)
	GoToState("Waiting")
EndEvent

EndState

State Sorting

Event OnActivate(ObjectReference akActionRef)
	debug.notification("Displaying items, please wait")
EndEvent

EndState


Function ResetDisplay()

	Index = DBM_JewelryUnique.GetSize()
	While index
			Index -= 1
			O = DBM_JewelryUnique.GetAt(index) as Objectreference
			If O.Isenabled()
				O.Disable()
				if DBM_Utils.getSharingEnabled()
					DBM_Utils.saveDisplayStatus(O)
				Endif
				DBM_DisplayMax.Value -= 1
			Endif
	EndWhile
EndFunction

Function UpdateDisplay()

	Index = DBM_JewelryUnique.GetSize()
	While index
			Index -= 1
			O = DBM_JewelryUnique.GetAt(index) as Objectreference
			if O.GetBaseObject() as Armor
				M = O.GetBaseObject() as Armor
				if Self.GetItemCount(M) >= 1
					O.Enable()
					if DBM_Utils.getSharingEnabled()
						DBM_Utils.saveDisplayStatus(O)
					Endif
				Endif
			Endif
	EndWhile
			if DBM_Utils.getSharingEnabled()
				DataMGR.EnableActiveDisplays()
			Endif
EndFunction

Function RefreshCount()
	Index = DBM_JewelryUnique.GetSize()			
	While index
			Index -= 1
			O = DBM_JewelryUnique.GetAt(index) as Objectreference
				if O.Isenabled()
					DBM_DisplayMax.Value += 1
				Endif

	EndWhile
	EndFunction
