Scriptname DBM_MAASE_GhostTriggerScript extends ObjectReference  
{Script for Ghost guiding player through ruins}

Explosion Property DramaticEntrance Auto
{VFX for ghost appearing}

ObjectReference Property StartingPos Auto
{Where the ghost appears -MyNowMarker}

Quest Property MAASE_Quest Auto
{Much Ado About Snow Elves}

Actor Property Ghost Auto
{The spooky ghost}

Scene Property WaitScene Auto
{Scene for ghost to wait}

Sound Property Speak Auto
{Becon the dragonborn to follow}
Sound Property SFX Auto
{SFX for ghost}

Int playerdoonce = 0
Int Property Delay Auto
{How long the ghost should be visible.}
Bool property FirstAppearance Auto
{Is it the first time the ghost appeared in these ruins?}

Function OnTriggerEnter (ObjectReference akPlayer)
	If akPlayer == Game.GetPlayer() && playerdoonce == 0 && MAASE_Quest.IsRunning() && !MAASE_Quest.IsCompleted()
		playerdoonce = 1
		if FirstAppearance == true
			Ghost.Disable()
			StartingPos.PlaceAtMe(DramaticEntrance, 1, false, false)
		EndIf
		Ghost.MoveTo(StartingPos)
		Ghost.Enable(True)
		Ghost.SetAlpha(0.6, true)
		WaitScene.Start()
		Speak.Play(akPlayer)
		SFX.Play(self)
		Utility.Wait(Delay)
		WaitScene.Stop()
		Ghost.Disable(True)
	EndIf
EndFunction