Scriptname DBM_MAASE_IceMeltScript extends ObjectReference  
{Script for melting Ice in MAASE}

Sound Property SFX Auto
{Ice SFX}
ObjectReference Property Mist auto
{Mist effect}
Keyword Property magicDamageFire auto
{Is it a fire spell?}

Bool property IsSheet = FALSE Auto
{True if ice blocking door. False if in boss room.}

Float NewScale
Float AngZ
Float AngX
Float PosY
Float PosZ
Float PosX
Float AngY
bool bMessage

Auto State Frozen

Event OnMagicEffectApply(ObjectReference akCaster, MagicEffect akEffect)
	if akEffect.HasKeyword(magicDamageFire)
		GoToState("Melting")
		NewScale = (Self.GetScale() - 0.1)
		PosX = self.GetPositionX()
		PosY = self.GetPositionY()
		PosZ = self.GetPositionZ()
		AngX = self.GetAngleX()
		AngY = self.GetAngleY()
		AngZ = self.GetAngleZ()
		if !bMessage
			Debug.Notification("The ice is melting! Keep it up!")
			bMessage = True
		endIf
		if Self.GetScale() < 0.6 ;if Ice block is 60% of original size, disable it.
			Self.Disable()
			Return
		EndIf
		SFX.Play(akCaster)
		Mist.SetPosition(PosX, PosY, PosZ)
		Mist.SetScale(Self.GetScale() / 2)
		if !IsSheet
			self.TranslateTo(PosX, PosY, (PosZ - NewScale * 13), AngX, AngY, AngZ, 10, 0)
		endIf
		while Self.GetScale() > NewScale
			Self.SetScale(Self.GetScale() - 0.025)
			Utility.Wait(0.2)
		endwhile
		Utility.Wait(0.2)
		GoToState("Frozen")
	EndIf
EndEvent

EndState

State Melting

Event OnMagicEffectApply(ObjectReference akCaster, MagicEffect akEffect)
	;The Ice is melting so do not process for additional strikes while this is happening.
EndEvent

EndState