Scriptname DBM_PerkTreeNodeScript extends ObjectReference  

Perk Property ThisPerk Auto
Sound Property UISkillsPerkSelect2DSND Auto
GlobalVariable Property DBM_ArcPerkToSpend Auto
GlobalVariable Property DBM_ArcPerkOwned Auto
GlobalVariable Property ArcPerkPickTree Auto

ObjectReference Property NextPerk1 Auto
ObjectReference Property NextPerk2 Auto
ObjectReference Property NextPerk3 Auto
ObjectReference Property NextPerk4 Auto

ObjectReference Property Branch1 Auto
ObjectReference Property Branch2 Auto
ObjectReference Property Branch3 Auto
ObjectReference Property Branch4 Auto

Location Property DBM_GuildhouseSolitudeLOC Auto

ObjectReference NP
ObjectReference B

Int Property PerkCount Auto
Int Property DoOnce Auto

Message Property PerkSpendMsg Auto
Int Property StartAvailable Auto

Event OnLoad()
If DoOnce == 0
	if StartAvailable == 1
		Self.PlayGameBryoAnimation("Unlocked")
		DoOnce = 1
	Endif
	if StartAvailable == 2
		Self.PlayGameBryoAnimation("Owned")
		if NextPerk1 != NONE
			NP = NextPerk1
			B = Branch1
			BuyPerk()
		Endif
		if NextPerk2 != NONE
			NP = NextPerk2
			B = Branch2
			BuyPerk()
		Endif
		if NextPerk3 != NONE
			NP = NextPerk3
			B = Branch3
			BuyPerk()
		Endif
		if NextPerk4 != NONE
			NP = NextPerk4
			B = Branch4
			BuyPerk()
		Endif
		DoOnce = 1
	Endif
Endif

If Game.GetPlayer().HasPerk(ThisPerk)
	Self.PlayGameBryoAnimation("Owned")
Else
	if ArcPerkPickTree.Value == PerkCount
		Self.PlayGameBryoAnimation("Unlocked")
	Endif
Endif

EndEvent

Event OnActivate(ObjectReference akActionRef)
	if akActionRef == Game.GetPlayer()
		if ArcPerkPickTree.Value >= PerkCount
			if Game.GetPlayer().HasPerk(ThisPerk) == False
				if DBM_ArcPerkToSpend.value > 0
				if !Utility.IsInMenuMode()
					int MyBtn = PerkSpendMSG.Show()
					if MyBtn == 0 ; yes
							Self.PlayGameBryoAnimation("Unlocked")
							Self.PlayGameBryoAnimation("Own")
							Self.PlayGameBryoAnimation("Owned")
							UISkillsPerkSelect2DSND.Play(Self)
							DBM_ArcPerkToSpend.Value -= 1
							Game.GetPlayer().AddPerk(ThisPerk)
							DBM_ArcPerkOwned.value += 1
							ArcPerkPickTree.Value += 1
							Self.BlockActivation()
						if NextPerk1 != NONE
							NP = NextPerk1
							B = Branch1
							BuyPerk()
						Endif
						if NextPerk2 != NONE
							NP = NextPerk2
							B = Branch2
							BuyPerk()
						Endif
						if NextPerk3 != NONE
							NP = NextPerk3
							B = Branch3
							BuyPerk()
						Endif
						if NextPerk4 != NONE
							NP = NextPerk4
							B = Branch4
							BuyPerk()
						Endif

					Elseif MyBtn == 1 ; no
						;cancel
					Endif
				Elseif Utility.IsInMenuMode()
						if (Game.GetPlayer()).GetCurrentLocation() == DBM_GuildhouseSolitudeLOC && Self.IsEnabled()
							Self.PlayGameBryoAnimation("Unlocked")
							Self.PlayGameBryoAnimation("Own")
							Self.PlayGameBryoAnimation("Owned")
							UISkillsPerkSelect2DSND.Play(Self)
						Endif
							DBM_ArcPerkToSpend.Value -= 1
							Game.GetPlayer().AddPerk(ThisPerk)
							DBM_ArcPerkOwned.value += 1
							ArcPerkPickTree.Value += 1
							Self.BlockActivation()
				Endif

				Elseif DBM_ArcPerkToSpend.Value == 0
					Debug.Messagebox("You don't have any Archeology Perk Points to spend")
				Endif
			Endif
		Elseif ArcPerkPickTree.value < PerkCount
			Debug.notification("You must purchase prerequisite perks first")
		Endif
	Endif
EndEvent

Function BuyPerk()
	B.PlayAnimation("Unlock")
	NP.PlayGameBryoAnimation("Unlock")
	NP.PlayGameBryoAnimation("Unlocked")
EndFunction