Scriptname DBM_PlanetariumScript extends ObjectReference  

ObjectReference Property StarMaps auto
FormList Property DBM_StarMapCubes Auto
MiscObject Property DBM_StarMapAetherium Auto
MiscObject Property DBM_StarMapStorm Auto
MiscObject Property DBM_StarMapConstilation Auto
MiscObject Property DBM_StarMapPlanets Auto
MiscObject Property DBM_StarMapSky Auto
Message Property DBM_PlanetariumControlMSG Auto
ObjectReference Property DBM_StarDome Auto
ObjectReference Property Mainlight Auto
ObjectReference Property Dome Auto
ObjectReference Property Nightlight Auto
Sound Property MAGCloakOut Auto
Sound Property DBM_PlanetdomeSND Auto

ObjectReference Property SnowStorm Auto

ObjectReference Property Planet1 Auto
ObjectReference Property Aether Auto

ObjectReference Property SkyDome Auto

ObjectReference Property SoundMark Auto

ObjectReference Property CubeStand Auto

ObjectReference Property Astrolab Auto

ObjectReference Property Array Auto
ObjectReference Property ArrayDome Auto
ObjectReference Property ArrayStars Auto

Actor Property Madras Auto
{Madras for scene.}

Int Playloop

auto State empty
	Event OnActivate(ObjectReference akActionRef)

if akActionRef == Game.GetPlayer()
	if akActionRef.GetItemCount(DBM_StarMapCubes) >= 1

				int CubeType = DBM_PlanetariumControlMSG.show()
					if CubeType == 0	;Aetherium
						GoToState("busy")
						Game.GetPlayer().RemoveItem(DBM_StarMapAetherium, 1, akothercontainer = StarMaps)
						CubeStand.PlayAnimation("SetDown")
						MAGCloakOut.Play(Game.GetPlayer())
						MainLight.Disable()
						DBM_PlanetdomeSND.Play(SoundMark)
						Aether.Enable(True)
						Utility.Wait(3)
						Dome.Disable(true)
						GoToState("loadedClosed")

					elseif CubeType == 1	;SnowStorm
						GoToState("busy")
						Game.GetPlayer().RemoveItem(DBM_StarMapStorm, 1, akothercontainer = StarMaps)
						CubeStand.PlayAnimation("SetDown")
						MAGCloakOut.Play(Game.GetPlayer())
						MainLight.Disable()
						DBM_PlanetdomeSND.Play(SoundMark)
						SnowStorm.Enable(true)
						Utility.Wait(3)
						Dome.Disable(true)
						GoToState("loadedClosed")

					elseif CubeType == 2	;Constellation
						GoToState("busy")
						Game.GetPlayer().RemoveItem(DBM_StarMapConstilation, 1, akothercontainer = StarMaps)
						CubeStand.PlayAnimation("SetDown")
						MAGCloakOut.Play(Game.GetPlayer())
						MainLight.Disable()
						DBM_PlanetdomeSND.Play(SoundMark)
						ArrayStars.Enable()
						ArrayDome.Enable(true)
						Array.Enable()
						Utility.Wait(3)
						Dome.Disable(true)
						GoToState("loadedClosed")
					elseif CubeType == 3	;Planetary
						GoToState("busy")
						Game.GetPlayer().RemoveItem(DBM_StarMapPlanets, 1, akothercontainer = StarMaps)
						CubeStand.PlayAnimation("SetDown")
						MAGCloakOut.Play(Game.GetPlayer())
						MainLight.Disable()
						DBM_PlanetdomeSND.Play(SoundMark)
						Planet1.Enable(True)
						Utility.Wait(3)
						Dome.Disable(true)
						GoToState("loadedClosed")
					elseif CubeType == 4	;Sky
						GoToState("busy")
						Game.GetPlayer().RemoveItem(DBM_StarMapSky, 1, akothercontainer = StarMaps)
						CubeStand.PlayAnimation("SetDown")
						MAGCloakOut.Play(Game.GetPlayer())
						MainLight.Disable()
						DBM_PlanetdomeSND.Play(SoundMark)
						SkyDome.Enable(True)
						Utility.Wait(3)
						Dome.Disable(true)
						GoToState("loadedClosed")
					Endif
	Endif
Elseif akActionRef == Madras && akActionRef.GetItemCount(DBM_StarMapPlanets) == 1
	GoToState("busy")
	Madras.RemoveItem(DBM_StarMapPlanets, 1, akothercontainer = StarMaps)
	CubeStand.PlayAnimation("SetDown")
	MAGCloakOut.Play(Game.GetPlayer())
	MainLight.Disable()
	DBM_PlanetdomeSND.Play(SoundMark)
	Planet1.Enable(True)
	Utility.Wait(3)
	Dome.Disable(true)
	GoToState("loadedClosed")	
EndIf
	EndEvent
EndState

State loadedClosed
	Event OnActivate(ObjectReference akActionRef)
		GoToState("busy")
		if StarMaps.GetItemCount(DBM_StarMapPlanets) == 1
			Self.PlayAnimation("StartPickup")
			MAGCloakOut.Play(Game.GetPlayer())
			StarMaps.RemoveAllItems(akTransferTo = Game.GetPlayer())
			DBM_PlanetdomeSND.Play(SoundMark)
			Dome.Enable(true)
			Planet1.Disable(True)
			MainLight.Enable()
			GoToState("empty")
			
		Elseif StarMaps.GetItemCount(DBM_StarMapConstilation) == 1
			Self.PlayAnimation("StartPickup")
			MAGCloakOut.Play(Game.GetPlayer())
			StarMaps.RemoveAllItems(akTransferTo = Game.GetPlayer())
			DBM_PlanetdomeSND.Play(SoundMark)
			Dome.Enable(true)
			Array.Disable()
			ArrayDome.Disable(true)
			ArrayStars.Disable()
			MainLight.Enable()
			GoToState("empty")
			
		Elseif StarMaps.GetItemCount(DBM_StarMapAetherium) == 1
			Self.PlayAnimation("StartPickup")
			MAGCloakOut.Play(Game.GetPlayer())
			StarMaps.RemoveAllItems(akTransferTo = Game.GetPlayer())
			DBM_PlanetdomeSND.Play(SoundMark)
			Dome.Enable(true)
			Aether.Disable(True)
			MainLight.Enable()
			GoToState("empty")
			
		Elseif StarMaps.GetItemCount(DBM_StarMapStorm) == 1
			Self.PlayAnimation("StartPickup")
			MAGCloakOut.Play(Game.GetPlayer())
			StarMaps.RemoveAllItems(akTransferTo = Game.GetPlayer())
			DBM_PlanetdomeSND.Play(SoundMark)
			Dome.Enable(true)
			SnowStorm.Disable(True)
			MainLight.Enable()
			GoToState("empty")
			
		Elseif StarMaps.GetItemCount(DBM_StarMapSky) == 1
			Self.PlayAnimation("StartPickup")
			MAGCloakOut.Play(Game.GetPlayer())
			StarMaps.RemoveAllItems(akTransferTo = Game.GetPlayer())
			DBM_PlanetdomeSND.Play(SoundMark)
			Dome.Enable(true)
			SkyDome.Disable(True)
			MainLight.Enable()
			GoToState("empty")
			
			Endif
	EndEvent

EndState


State busy
	
EndState
