Scriptname DBM_RadiantAddons extends Quest  
{Handles addition functions from addon mods for radiant quests.}

FormList Property DBM_UTItems Auto
{SkyrimsUniqueTreasures Supported Items List}
FormList Property DBM_HeadsItems Auto
{BG Trophy Heads Supported Items}
FormList Property DBM_FairyItems Auto
{Fairy Supported Items}
FormList Property DBM_FishItems Auto
{Fish Bowl Items}
FormList Property DBM_JarItems Auto
{Jar Hunt Items}

ObjectReference Property DISPLAYCHEST Auto
ObjectReference Property DISPLAYCHEST2 Auto
FormList Property DBM_RadiantRelicBase Auto
FormList Property DBM_RadiantRelicList Auto

Function ExtendRelics()
Utility.Wait(4)
int before = DBM_RadiantRelicList.GetSize()
int i = Game.GetModByName("SkyrimsUniqueTreasures.esp")
if i != 255
	AddSUT()
	Utility.Wait(1)
EndIf
i = Game.GetModByName("BGTrophyHeads.esp")
if i != 255
	AddBGTrophyHeads()
	Utility.Wait(1)
EndIf
i = Game.GetModByName("BGtheCapturedFairies.esp")
if i != 255
	AddBGFairies()
	Utility.Wait(1)
EndIf
i = Game.GetModByName("BGSomethingFishy.esp")
if i != 255
	AddBGFishBowls()
	Utility.Wait(1)
EndIf
i = Game.GetModByName("BadGremlinsJarHunt.esp")
if i != 255
	AddBGJars()
	Utility.Wait(1)
EndIf
Utility.Wait(2)
int after = DBM_RadiantRelicList.GetSize()
if before < after
	Debug.Trace("Radiant Relic list increased from " + before + " to " + after + ".")
endif
GoToState("Completed")
EndFunction

Function AddSUT()
;SUT Handler
	int x = DBM_UTItems.GetSize()
		while x
			x -=1
			Form SUTItem = DBM_UTItems.GetAt(x)
			if DISPLAYCHEST.GetItemCount(SUTItem) == 0 && Game.GetPlayer().GetItemCount(SUTItem) == 0 && DISPLAYCHEST2.GetItemCount(SUTItem) == 0
				DBM_RadiantRelicBase.AddForm(SUTItem)
				DBM_RadiantRelicList.AddForm(SUTItem)
			endif
		EndWhile
			;Debug.Trace("SkyrimsUniqueTreasures items added to Radiant Relic List")
EndFunction

Function AddBGTrophyHeads()
;Trophy Heads handler
	int x = DBM_HeadsItems.GetSize()
		while x
			x -=1
			Form HeadItem = DBM_HeadsItems.GetAt(x)
			if DISPLAYCHEST.GetItemCount(HeadItem) == 0 && Game.GetPlayer().GetItemCount(HeadItem) == 0 && DISPLAYCHEST2.GetItemCount(HeadItem) == 0
				DBM_RadiantRelicBase.AddForm(HeadItem)
				DBM_RadiantRelicList.AddForm(HeadItem)
			endif
		EndWhile
			;Debug.Trace("Trophy Heads added to Radiant Relic List")
EndFunction

Function AddBGFairies()
;Fairy handler
	int x = DBM_FairyItems.GetSize()
		while x
			x -=1
			Form FairyItem = DBM_FairyItems.GetAt(x)
			if DISPLAYCHEST.GetItemCount(FairyItem) == 0 && Game.GetPlayer().GetItemCount(FairyItem) == 0 && DISPLAYCHEST2.GetItemCount(FairyItem) == 0
				DBM_RadiantRelicBase.AddForm(FairyItem)
				DBM_RadiantRelicList.AddForm(FairyItem)
			endif
		EndWhile
			;Debug.Trace("Fairies added to Radiant Relic List")
EndFunction

Function AddBGFishBowls()
;Fish Bowl handler
	int x = DBM_FishItems.GetSize()
		while x
			x -=1
			Form FishItem = DBM_FishItems.GetAt(x)
			if DISPLAYCHEST.GetItemCount(FishItem) == 0 && Game.GetPlayer().GetItemCount(FishItem) == 0 && DISPLAYCHEST2.GetItemCount(FishItem) == 0
				DBM_RadiantRelicBase.AddForm(FishItem)
				DBM_RadiantRelicList.AddForm(FishItem)
			endif
		EndWhile
			;Debug.Trace("Fish Bowls added to Radiant Relic List")
EndFunction

Function AddBGJars()
;Jar Hunt handler
	int x = DBM_JarItems.GetSize()
		while x
			x -=1
			Form JarItem = DBM_JarItems.GetAt(x)
			if DISPLAYCHEST.GetItemCount(JarItem) == 0 && Game.GetPlayer().GetItemCount(JarItem) == 0 && DISPLAYCHEST2.GetItemCount(JarItem) == 0
				DBM_RadiantRelicBase.AddForm(JarItem)
				DBM_RadiantRelicList.AddForm(JarItem)
			endif
		EndWhile
			;Debug.Trace("Jar Hunt items added to Radiant Relic List")
EndFunction

State Completed

Function ExtendRelics()
debug.notification("Addon function is rerunning but failing due to changed states.");
EndFunction

Function AddSUT()
;
EndFunction

Function AddBGTrophyHeads()
;
EndFunction

Function AddBGFairies()
;
EndFunction

Function AddBGFishBowls()
;
EndFunction

Function AddBGJars()
;
EndFunction

EndState
