Scriptname DBM_ResearchStationScript extends ObjectReference  
{Script controlling searching for artifact based on books read.}

Quest Property DBM_ResearchQST Auto
{Radiant Quest}
Message Property DBM_ResearchMSG Auto
Message Property DBM_ResearchFailMSG Auto
Message Property DBM_ResearchBusyMSG Auto

FormList[] Property arDisplayItems Auto
{An array containing items formlists, paired with arDisplays}
FormList[] Property arDisplays Auto
{An array containing display formlists, paired with arDisplayItems}
FormList[] Property arBookDisplays Auto
{An array containing display formlists, paired with arBookItems}
FormList[] Property arBookItems Auto
{An array containing items formlists, paired with arBookDisplays}
FormList Property DBM_ResearchList Auto
{List built by this function for using in the Radiant Quest}

Int Property aiBookTarget = 10 Auto
{How many RP are required to research a book, DEFAULT = 10}
Int Property aiRelicTarget = 20 Auto
{How many RP are required to research a relic, DEFAULT = 20}

Bool bTaskOnGoing ;if the quest is running
Int aiResearchPoints ;RP gained
Int aiBooksRead ;Books recorded last time this was activated


Auto State Ready

Event OnActivate(ObjectReference akActionRef)
	if akActionRef == Game.GetPlayer() && Self.IsFurnitureInUse()
		Utility.Wait(2.5)
		GoToState("Working")
		if ResearchReady()
			int aiButton = DBM_ResearchMSG.Show(aiResearchPoints, aiBookTarget, aiRelicTarget)
			if aiButton == 0 ;Books
				aiResearchPoints -= aiBookTarget
				bTaskOnGoing = True
				Game.ForceThirdPerson()
				Debug.SendAnimationEvent(Game.GetPlayer(), "ChairReadingStart")
				Game.DisablePlayerControls(True, True, True, False, True, True, True, True)
				DBM_ResearchList.Revert()
				int total = arBookDisplays.Length
				int index
				DBM_ResearchList.Revert()
				while index < total
					ItemCheck(arBookDisplays[index], arBookItems[index])
					if index == 0
						Debug.notification("This could be the lead I was looking for!")
						Utility.Wait(2)
					endif
					index += 1
				endwhile
				Game.EnablePlayerControls()
				Debug.notification("Ah ha! I've found it!")
				DBM_ResearchQST.SetStage(5)
			elseif aiButton == 1 ;Relic Project
				if aiResearchPoints >= aiRelicTarget
					aiResearchPoints -= aiRelicTarget
					bTaskOnGoing = True
					Game.ForceThirdPerson()
					Debug.SendAnimationEvent(Game.GetPlayer(), "ChairReadingStart")
					Debug.notification("This may take a while...")
					Game.DisablePlayerControls(True, True, True, False, True, True, True, True)
					int total = arDisplays.Length
					int index
					DBM_ResearchList.Revert()
					while index < total
						ItemCheck(arDisplays[index], arDisplayItems[index])
						if index == 3
							Debug.notification("Hmmm this is interesting...")
							Debug.SendAnimationEvent(Game.GetPlayer(), "ChairReadingIdles")
						elseif index == 5
							Debug.notification("No, that can't be right...")
							Debug.SendAnimationEvent(Game.GetPlayer(), "ChairReadingStart")
						elseif index == 10
							Debug.notification("Ah, maybe one of these volumes?")
							Utility.Wait(2.5)
							Debug.SendAnimationEvent(Game.GetPlayer(), "ChairReadingIdles")
						elseif index == 16
							Utility.Wait(2.5)
							Debug.notification("Ah ha, now I am on to something...")
							Debug.SendAnimationEvent(Game.GetPlayer(), "IdleWriteTableChairEnterInstant")
						elseif index == 21
							Utility.Wait(2.5)
							Debug.notification("That's rather interesting...")
							Debug.SendAnimationEvent(Game.GetPlayer(), "IdleWriteTableChairEnterInstant")
						elseif index == 26
							Utility.Wait(2.5)
							Debug.notification("Yes... yes....This must be it!")
							Debug.SendAnimationEvent(Game.GetPlayer(), "ChairReadingStart")
						endif
						index += 1
					endwhile
					Game.EnablePlayerControls()
					Debug.notification("Ah ha! I've found it!")
					DBM_ResearchQST.SetStage(5)
				else
					DBM_ResearchFailMSG.Show(aiRelicTarget,aiResearchPoints)
				endif
			elseif aiButton == 2
				;Do nothing.
			endif
			Utility.Wait(2)
			Self.Activate(Game.GetPlayer())
			Utility.Wait(2.5)
			Debug.SendAnimationEvent(Game.GetPlayer(), "IdleForceDefaultState")
			GoToState("Ready")
		elseif bTaskOnGoing
			;Debug.MessageBox("I'd better track down the item I am currently researching first.")
			int t = DBM_ResearchBusyMSG.Show()
			if t == 0
				DBM_ResearchQST.SetActive()
			elseif t == 1
				DBM_ResearchQST.SetStage(20)
				bTaskOnGoing = FALSE
			endif
			Self.Activate(Game.GetPlayer())
			Utility.Wait(2.5)
			Debug.SendAnimationEvent(Game.GetPlayer(), "IdleForceDefaultState")
			GoToState("Ready")
		else
			DBM_ResearchFailMSG.Show(aiBookTarget,aiResearchPoints)
			Self.Activate(Game.GetPlayer())
			Utility.Wait(2.5)
			Debug.SendAnimationEvent(Game.GetPlayer(), "IdleForceDefaultState")
			GoToState("Ready")
		endif
	endif
EndEvent

EndState

State Working
;nothing here
EndState

Bool Function ResearchReady() 
	if !DBM_ResearchQST.IsRunning() && bTaskOnGoing
		bTaskOnGoing = False
	endif
	
	int iGameBooksRead = Game.QueryStat("Books Read") + Game.QueryStat("Skill Books Read")
	aiResearchPoints = aiResearchPoints + (iGameBooksRead - aiBooksRead)
	aiBooksRead = iGameBooksRead
	if (aiResearchPoints >= aiBookTarget) && !bTaskOnGoing ;Enough points and quest is not running.
		Return True
	else
		Return False
	endif
EndFunction

Function ItemCheck(FormList Displays, FormList Items)
	int Index = Displays.GetSize()
	While Index
		Index -= 1
		ObjectReference O = Displays.GetAt(Index) as ObjectReference
		Form I = Items.GetAt(Index) as Form
		if O.IsDisabled() && !DBM_ResearchList.HasForm(I)
			DBM_ResearchList.AddForm(I)
		elseif !O.IsDisabled() && DBM_ResearchList.HasForm(I)
			DBM_ResearchList.RemoveAddedForm(I)
		Endif
	EndWhile
EndFunction