Scriptname DBM_SloadCombatScript extends ObjectReference  
{Revised boss battle script with Malsato the Hungry by Pickysaurs}

Actor Property aMinion1 Auto
{First minion}
Actor Property aMinion2 Auto
{Second minion}

Actor Property oSload Auto
{The Greaseball himself.}

Spell Property DummySpell Auto
{Casting Special FX}

EffectShader Property SkeletonNecroDeathFXS auto
Activator property AshPileObject auto

Float CurrentHealth
Float BaseHealth
Float HealthPercent

Event OnCombatStateChanged(Actor akTarget, int aeCombatState)
	if akTarget == Game.GetPlayer() && aeCombatState == 1
	RegisterForUpdate(10)
	endif
EndEvent

Event OnUpdate()
if GetSloadHealth() > 5 && oSload.Is3DLoaded()
	if aMinion1.IsDead()
        Self.PlayAnimation("summonStart")
        Utility.Wait(1)
        DummySpell.Cast(Self, aMinion1)
        aMinion1.Resurrect()
		Utility.Wait(2)
    endif
	if aMinion2.IsDead()
        Self.PlayAnimation("summonStart")
        Utility.Wait(1)
        DummySpell.Cast(Self, aMinion2)
        aMinion2.Resurrect()
    endif
elseif oSload.IsDead() || !oSload.Is3DLoaded()
	UnregisterforUpdate()
else
;
EndIf
EndEvent

Event OnDying(Actor akKiller)
	Actor SelfRef = oSload
	SkeletonNecroDeathFXS.play(SelfRef)
	
	SelfRef.SetCriticalStage(SelfRef.CritStage_DisintegrateStart)
	SelfRef.AttachAshPile(AshPileObject)
	
	utility.wait(2)	
	SelfRef.SetAlpha (0.0)
	SelfRef.SetCriticalStage(SelfRef.CritStage_DisintegrateEnd)
EndEvent

Event OnDeath(Actor akKiller)
	if !aMinion1.IsDead()
		aMinion1.Kill()
	endif
	if !aMinion2.IsDead()
		aMinion2.Kill()
	endif
UnregisterForUpdate()
EndEvent

Float Function GetSloadHealth()
	CurrentHealth = oSload.GetActorValue("Health")
	BaseHealth = oSload.GetBaseActorValue("Health")
	HealthPercent = (CurrentHealth/BaseHealth) * 100
	return HealthPercent
EndFunction