Scriptname DBM_switchscript extends ObjectReference  

{Controls a set of lights with a master enable parent
marker (EnableMarker) and a switch with this script
attached to turn on and off when the switch is activated}
 
ObjectReference Property EnableMarker auto
{The marker set as the enable parent of all the lights}
 
Event OnInit()
 
	If (EnableMarker.IsDisabled())
		GoToState("LightsOff")
	Else
		GoToState("LightsOn")
	EndIf
 
EndEvent
 
State LightsOff
 
	Event OnBeginState()
		EnableMarker.Disable()
	EndEvent
 
	Event OnActivate(ObjectReference akActionRef)
		GoToState("LightsOn")
	EndEvent
 
EndState
 
State LightsOn
 
	Event OnBeginState()
		EnableMarker.Enable()
	EndEvent
 
	Event OnActivate(ObjectReference akActionRef)
		GoToState("LightsOff")
	EndEvent
 
EndState