Scriptname DBM_TotemLockScript extends ObjectReference  

ObjectReference Property TotemKeyChest Auto
MiscObject Property TotemKey Auto
ObjectReference Property TotemDoor1 Auto
ObjectReference Property TotemDoor2 Auto
ObjectReference Property TotemDoor3 Auto
Quest Property MyQuest Auto
Int Property QstSTG Auto
Int Property NextSTG Auto

Auto State DoorClosed

Event OnActivate(ObjectReference akActionRef)
	if GetLinkedRef().IsDisabled() && akActionRef.GetItemCount(TotemKey) == 1
		akActionRef.RemoveItem(TotemKey, 1, akOtherContainer = TotemKeyChest)
		GetLinkedRef().Enable()
		if MyQuest.GetStage() < QstSTG
			MyQuest.SetStage(NextSTG)
		Endif
		TotemDoor1.Playanimation("open")
		TotemDoor1.Activate(Self)
		Utility.Wait(2)
		TotemDoor2.Playanimation("open")
		TotemDoor2.Activate(Self)
		Utility.Wait(2)
		TotemDoor3.Playanimation("open")
		TotemDoor3.Activate(Self)
		GoToState("DoorOpened")
	Else
		Debug.Notification("You Lack the Required Item")
	Endif
EndEvent

EndState

State DoorOpened

Event OnActivate(ObjectReference akActionRef)
	if GetLinkedRef().IsEnabled()
		TotemKeyChest.RemoveItem(TotemKey, 1, akOtherContainer = Game.GetPlayer())
		GetLinkedRef().Disable()
		TotemDoor3.Playanimation("close")
		TotemDoor3.Activate(Self)
		Utility.Wait(2)
		TotemDoor2.Playanimation("close")
		TotemDoor2.Activate(Self)
		Utility.Wait(2)
		TotemDoor1.Playanimation("close")
		TotemDoor1.Activate(Self)
		GoToState("DoorClosed")
	Endif
EndEvent

EndState