Scriptname DBM_TransmuteScript extends ObjectReference  
{Controls the transmutation forge.}

;;WEAPON KEYWORDS
Keyword Property WeapTypeBattleaxe Auto
Keyword Property WeapTypeWaraxe Auto
Keyword Property WeapTypeSword Auto
Keyword Property WeapTypeGreatsword Auto
Keyword Property WeapTypeDagger Auto
Keyword Property WeapTypeBow Auto
Keyword Property WeapTypeMace Auto
Keyword Property WeapTypeStaff Auto
Keyword Property WeapTypeWarhammer Auto

;;ARMOUR KEYWORDS
Keyword Property ArmorBoots Auto
Keyword Property ArmorGauntlets Auto
Keyword Property ArmorHelmet Auto
Keyword Property ArmorCuirass Auto
Keyword Property ArmorShield Auto
Keyword Property ArmorClothing Auto
Keyword Property ArmorJewelry Auto

;;CONTAINERS
ObjectReference Property ContainerA Auto
ObjectReference Property ContainerB Auto

;;TRANSMUTE SFX/VFX
Spell Property Lightningbolt Auto
Sound Property DBM_ShockSound Auto
Sound Property DBM_DweRespositorySND Auto
ObjectReference Property GlassRod001 Auto
ObjectReference Property GlassRod002 Auto
ObjectReference Property GlassRod003 Auto
ObjectReference Property GlassRod004 Auto
ObjectReference Property GlassRod005 Auto
ObjectReference Property GlassRod006 Auto
ObjectReference Property GlassRod007 Auto
ObjectReference Property GlassRod008 Auto

;;VARIABLES
Bool Male
Bool ContAArmour
Bool ContAWeapon
Bool ContBArmour
Bool ContBWeapon
Keyword ContAKWD
Keyword ContBKWD 

Event OnActivate(ObjectReference akActionRef)
	if akActionRef == Game.GetPlayer()
		ActorBase PlayerBase = Game.GetPlayer().GetActorBase()
		if PlayerBase.GetSex() == 0 
			Male = True
		Else
			Male = False
		EndIf
		GetKeywordA(ContainerA.GetNthForm(0))
		GetKeywordB(ContainerB.GetNthForm(0))
			if (ContAWeapon && ContBWeapon) && (ContAKWD == ContBKWD)
				Weapon WeaponA = ContainerA.GetNthForm(0) as weapon
				Weapon WeaponB = ContainerB.GetNthForm(0) as weapon
				String WeaponAPath = WeaponA.Getmodelpath()
				Static EquippedModel = WeaponA.GetEquippedModel() 
				WeaponB.Setmodelpath(WeaponAPath) 
				WeaponB.SetEquippedModel(EquippedModel)
				Transmute()
				Debug.Notification("Transmutation process complete")
			Elseif (ContAWeapon && ContBWeapon) && (ContAKWD != ContBKWD)
				Debug.Messagebox("Both weapons must be the same type for the Tramsmutation to succeed.")
			Elseif (ContAArmour && ContBArmour) && (ContAKWD == ContBKWD)
				Armor ArmorA = ContainerA.GetNthForm(0) as armor
				Armor ArmorB = ContainerB.GetNthForm(0) as armor
					if Male
						String ArmorAGRND = ArmorA.Getmodelpath(bFemalePath = False)
						ArmorB.SetModelPath(ArmorAGRND, bFemalePath = False)
						ArmorAddon ArmorAA = ArmorA.GetNthArmorAddon(0)
						String mArmorAWorn = ArmorAA.GetModelPath(false, false) ; male worn armor
						String mArmorAPOV = ArmorAA.GetModelPath(true, false) ; male POV armor
						ArmorAddon ArmorBA = ArmorB.GetNthArmorAddon(0)						
						ArmorBA.SetModelPath(mArmorAWorn, false, false) ; male worn armor
						ArmorBA.SetModelPath(mArmorAPOV, true, false) ; male POV armor
						Transmute()
						Debug.Notification("Transmutation process complete")
					Elseif !Male
						String ArmorAGRND = ArmorA.Getmodelpath(bFemalePath = True)
						ArmorB.SetModelPath(ArmorAGRND, bFemalePath = True)
						ArmorAddon ArmorAA = ArmorA.GetNthArmorAddon(0)
						String fArmorAWorn = ArmorAA.GetModelPath(true, true) ; female worn armor
						String fArmorAPOV= ArmorAA.GetModelPath(false, true) ; female POV armor
						ArmorAddon ArmorBA = ArmorB.GetNthArmorAddon(0)						
						ArmorBA.SetModelPath(fArmorAWorn, false, true) ; female worn armor
						ArmorBA.SetModelPath(fArmorAPOV, true, true) ; female POV armor
						Transmute()
						Debug.Notification("Transmutation process complete")
					Endif
			Elseif (ContAArmour && ContBArmour) && (ContAKWD != ContBKWD)
				Debug.Messagebox("Both items must be the worn on that same part of the body for the Tramsmutation to succeed.")
			Else
				Debug.MessageBox("You must place a source weapon or armor into the left receptacle and a target of the same type in the right receptacle")
			Endif
		;Revert the variables
		ContAKWD = None 
		ContBKWD = None
		ContAArmour = False
		ContAWeapon = False
		ContBArmour = False
		ContBWeapon = False
	Endif
EndEvent

Function GetKeywordA(Form akItem)
	if akItem.HasKeyword(WeapTypeBattleAxe)
		ContAKWD = WeapTypeBattleAxe
	elseif akItem.HasKeyword(WeapTypeWarAxe) 
		ContAKWD = WeapTypeWarAxe
	elseif akItem.HasKeyword(WeapTypeSword) 
		ContAKWD = WeapTypeSword
	elseif akItem.HasKeyword(WeapTypeGreatsword) 
		ContAKWD = WeapTypeGreatsword
	elseif akItem.HasKeyword(WeapTypeDagger) 
		ContAKWD = WeapTypeDagger
	elseif akItem.HasKeyword(WeapTypeBow) 
		ContAKWD = WeapTypeBow
	elseif akItem.HasKeyword(WeapTypeMace) 
		ContAKWD = WeapTypeMace
	elseif akItem.HasKeyword(WeapTypeStaff) 
		ContAKWD = WeapTypeStaff
	elseif akItem.HasKeyword(WeapTypeWarhammer)
		ContAKWD = WeapTypeWarAxe
	endif
	if ContAKWD != None
		ContAWeapon = True
		;debug.notification("Contain A has a weapon inside.")
	endif
	if !ContAWeapon
		if akItem.HasKeyword(ArmorBoots) 
			ContAKWD = ArmorBoots
		elseif akItem.HasKeyword(ArmorGauntlets) 
			ContAKWD = ArmorGauntlets	
		elseif akItem.HasKeyword(ArmorHelmet) 
			ContAKWD = ArmorHelmet	
		elseif akItem.HasKeyword(ArmorCuirass) 
			ContAKWD = ArmorCuirass	
		elseif akItem.HasKeyword(ArmorShield) 
			ContAKWD = ArmorShield	
		elseif akItem.HasKeyword(ArmorClothing) 
			ContAKWD = ArmorClothing	
		elseif akItem.HasKeyword(ArmorJewelry)
			ContAKWD = ArmorJewelry	
		endif
		ContAArmour = True
		;debug.notification("Container A has armour inside.")
	endif
EndFunction

Function GetKeywordB(Form akItem)
	if akItem.HasKeyword(WeapTypeBattleAxe)
		ContBKWD = WeapTypeBattleAxe
	elseif akItem.HasKeyword(WeapTypeWarAxe) 
		ContBKWD = WeapTypeWarAxe
	elseif akItem.HasKeyword(WeapTypeSword) 
		ContBKWD = WeapTypeSword
	elseif akItem.HasKeyword(WeapTypeGreatsword) 
		ContBKWD = WeapTypeGreatsword
	elseif akItem.HasKeyword(WeapTypeDagger) 
		ContBKWD = WeapTypeDagger
	elseif akItem.HasKeyword(WeapTypeBow) 
		ContBKWD = WeapTypeBow
	elseif akItem.HasKeyword(WeapTypeMace) 
		ContBKWD = WeapTypeMace
	elseif akItem.HasKeyword(WeapTypeStaff) 
		ContBKWD = WeapTypeStaff
	elseif akItem.HasKeyword(WeapTypeWarhammer)
		ContBKWD = WeapTypeWarAxe
	endif
	if ContBKWD != None
		ContBWeapon = True
		;debug.notification("Contain B has a weapon inside.")
	endif
	if !ContBWeapon
		if akItem.HasKeyword(ArmorBoots) 
			ContBKWD = ArmorBoots
		elseif akItem.HasKeyword(ArmorGauntlets) 
			ContBKWD = ArmorGauntlets	
		elseif akItem.HasKeyword(ArmorHelmet) 
			ContBKWD = ArmorHelmet	
		elseif akItem.HasKeyword(ArmorCuirass) 
			ContBKWD = ArmorCuirass	
		elseif akItem.HasKeyword(ArmorShield) 
			ContBKWD = ArmorShield	
		elseif akItem.HasKeyword(ArmorClothing) 
			ContBKWD = ArmorClothing	
		elseif akItem.HasKeyword(ArmorJewelry)
			ContBKWD = ArmorJewelry	
		endif
		ContBArmour = True
		;debug.notification("Container B has armour inside.")
	endif
EndFunction

Function Transmute()
	DBM_DweRespositorySND.Play(self)
	DBM_ShockSound.play(Self)
	LightningBolt.cast(GlassRod001, Glassrod002)
	Utility.Wait(0.5)
	DBM_ShockSound.play(Self)
	LightningBolt.cast(GlassRod005, Glassrod007)
	Utility.Wait(0.2)
	DBM_ShockSound.play(Self)
	LightningBolt.cast(GlassRod001, Glassrod003)
	Utility.Wait(0.2)
	DBM_ShockSound.play(Self)
	LightningBolt.cast(GlassRod005, Glassrod008)
	DBM_ShockSound.play(Self)
	LightningBolt.cast(GlassRod001, Glassrod004)
	Utility.Wait(0.1)
	DBM_ShockSound.play(Self)
	LightningBolt.cast(GlassRod005, Glassrod002)
	DBM_ShockSound.play(Self)
	LightningBolt.cast(GlassRod001, Glassrod006)
	Utility.Wait(0.4)
	DBM_ShockSound.play(Self)
	LightningBolt.cast(GlassRod001, Glassrod008)
	DBM_ShockSound.play(Self)
	LightningBolt.cast(GlassRod005, Glassrod003)
	Utility.Wait(0.2)
	DBM_ShockSound.play(Self)
	LightningBolt.cast(GlassRod005, Glassrod004)
	DBM_ShockSound.play(Self)
	LightningBolt.cast(GlassRod001, Glassrod007)
	Utility.Wait(0.2)
	DBM_ShockSound.play(Self)
	LightningBolt.cast(GlassRod005, Glassrod006)
EndFunction