Scriptname DBM_WaterfountainScript extends ObjectReference  

Form Water01
Form WaterSkin1
Form WaterSkin2
Form WaterSkin3
Form LSWater

Int iNeedSkins

Event OnInit() ;Idenify which needs mod, if any to support.
	bool RND
	bool iNeed
	bool LastSeed
	if Game.GetFormFromFile(0x005968, "RealisticNeedsAndDiseases.esp")
		RND = True
	endif
	if Game.GetFormFromFile(0x00438C, "iNeed.esp")
		iNeed = True
	endif 
	if Game.GetFormFromFile(0x0029D5, "LastSeed.esp") ;Currently points to last seed Thirst System Quest
		LastSeed = True
	endif
	if ((iNeed && LastSeed) || (RND && (iNeed || LastSeed)))
		Debug.TraceAndBox("Legacy of the Dragonborn has detected multiple needs mods. Switching off needs support to avoid incompatibilities.", 1)
		GoToState("Vanilla")
	elseif RND
		GoToState("RNDState")
	elseif iNeed
		GoToState("iNeedState")
	elseif LastSeed
		GoToState("LastSeedState")
	else
		GoToState("Vanilla")	
	endif
EndEvent

State Vanilla
	Event OnInit()
		;
	EndEvent
	
	Event OnActivate(ObjectReference akActionRef)
		if akActionRef == Game.GetPlayer()
			Self.GetLinkedRef().Enable(True)
			Debug.Notification("You have a refreshing drink and wash up")
			Utility.Wait(3)
			Self.GetLinkedRef().Disable(true)
		endif
	EndEvent
EndState

State RNDState
	Event OnInit()
		;
	EndEvent
	
	Event OnActivate(ObjectReference akActionRef)
		if akActionRef == Game.GetPlayer() 
			Self.GetLinkedRef().Enable(True)
			Water01 = Game.GetFormFromFile(0x005968, "RealisticNeedsAndDiseases.esp")
			Game.GetPlayer().Additem(Water01, 1)
			Utility.Wait(3)
			Self.GetLinkedRef().Disable(true)
		endif
	EndEvent
EndState

State iNeedState
	Event OnInit()
		;
	EndEvent
	
	Event OnActivate(ObjectReference akActionRef)
		if akActionRef == Game.GetPlayer()
			Self.GetLinkedRef().Enable(True)
			WaterSkin1 = Game.GetFormFromFile(0x00438C, "iNeed.esp")  ; empty skin
			WaterSkin2 = Game.GetFormFromFile(0x00437F, "iNeed.esp")  ; 1/3 full skin
			WaterSkin3 = Game.GetFormFromFile(0x00437D, "iNeed.esp")  ; 2/3 ull skin
			Water01 = Game.GetFormFromFile(0x004376, "iNeed.esp") ; Full waterskin
			iNeedSkins = (Game.GetPlayer().GetItemCount(WaterSkin1) + Game.GetPlayer().GetItemCount(WaterSkin2) + Game.GetPlayer().GetItemCount(WaterSkin3))
			if iNeedSkins > 0 
			while Game.GetPlayer().GetItemCount(WaterSkin1) > 0
					Game.GetPlayer().RemoveItem(WaterSkin1, 1, true)
					Game.GetPlayer().AddItem(Water01, 1, true)
			endwhile
			while Game.GetPlayer().GetItemCount(WaterSkin2) > 0
					Game.GetPlayer().RemoveItem(WaterSkin2, 1, true)
					Game.GetPlayer().AddItem(Water01, 1, true)
			endwhile
			while Game.GetPlayer().GetItemCount(WaterSkin3) > 0
					Game.GetPlayer().RemoveItem(WaterSkin3, 1, true)
					Game.GetPlayer().AddItem(Water01, 1, true)
			endwhile
			Debug.Notification("" + iNeedSkins + " water skins refilled")
			iNeedSkins = 0
			Else
				Debug.Notification("You need a water skin")
			Endif
			Utility.Wait(3)
			Self.GetLinkedRef().Disable(true)
		endif
	EndEvent
EndState

State LastSeedState
	Event OnInit()
		;
	EndEvent
	
	Event OnActivate(ObjectReference akActionRef)
		if akActionRef == Game.GetPlayer() 
			Self.GetLinkedRef().Enable(True)
			Debug.Notification("You have a refreshing drink and wash up")
			Utility.Wait(3)
			Self.GetLinkedRef().Disable(true)
			Debug.Trace("Last Seed does not yet support thirst. Reverting to Vanilla mode.")
			GoToState("Vanilla")
		endif
	EndEvent
EndState